#!/usr/local/bin/perl
#
# dcextra.cgi
# DCForum99 Version 1.1
# Part of DCForum by DCScripts
# Copyright  1997-1999 DCScripts All Rights Reserved
# 
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCForum.
# You should carefully read this terms agreement as outlined in
# the readme.txt file included with this distribution before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
###################################################################

# NOTE: You may need to provide full path to each setup files
# Some server require this.
# $path is the directory path to the location of this file.

$path = ".";

#>>>>>>>>>>>>>>> NO NEED TO EDIT ANYTHING BELOW THIS LINE <<<<<<<<

require "$path/dcforum.setup";
require "$path/dcboard.setup";
require "$cgidir/cgi-lib.pl";
require "$cgidir/dcforumlib.pl";
require "$cgidir/dcforumlib2.pl";
require "$cgidir/dclib.pl";
require "$cgidir/dcprotect.pl";

&ReadParse;

unless ($in{'az'} eq "mark") {
	print "Content-type: text/html\n";
}

$r_in = \%in;

$r_in->{'time_stamp'} = "time_stamp";
$r_in->{'expires'} = "Fri, 31-Dec-99 12:00:00 GMT";


if ($r_in->{'database'} eq "" || $r_in->{'database'} ne 'archive') {
   	$r_in->{'database'} = $database;
}
else {
  $database = "arc_" . $database;
   $r_in->{'arc_database'} = $database;
}

get_date($r_in);

$r_setup = initialize($password_file_dir,$forum_file,$board_setup_file);

# Set Global variables

require "$path/global.pl";

# If the input forum type is Private, then
# set appropriate file extension and dir

if ($r_setup->{'forum_type'}->{ $r_in->{'forum'} } eq 'Private') {
   $ext = $privateext;
   $maindir = $privatedir;
}

# Check to see if there are some action key from
# user authentication program

# Global variables

$forum = $in{'forum'};
$az = $in{'az'};

# OK, before we do anything, let's check the user's cookie
# If Cookie exists, COOL
# If Forum is Private but no cookie, then
# Call on DCProtect

$r_in->{'userdata'} = {};
$session = get_cookie($cookie_name);
if ($session) {
	if (-e "$password_file_dir/$session.session") {
		$r_in->{'userdata'} = get_userdata("$password_file_dir/$session.session");
	}
	else {
	   send_cookie($cookie_name,'','Thur, 31-Dec-98 12:00:00 GMT','/');
		$session = '';
	}
}
elsif ($r_setup->{'forum_type'}->{$forum} eq 'Private') {
     $r_in->{'userdata'} = dcprotect($exurl,$password_file_dir,$r_in,
      \@login_fields,\%field_form_type);
}


# Next readin the team members
$team = get_team_members("$password_file_dir/$team_file_name");

if ($az eq "show_thread") {

   print "\n";

	# Create menu buttons
   $menu_button = create_button('list',$r_in,$r_setup);
	
	# Oppps, no access allowed
   if ($r_setup->{'forum_status'}->{ $forum } ne "on") {
		($heading,$sub_heading,$html_output) = 
			access_error('forum off',$r_in,$r_setup);
   }
   elsif (!check_forum_access($r_in,$r_setup,$forum)) {
		($heading,$sub_heading,$html_output) = 
			access_error('forum private',$r_in,$r_setup);
   }
   else {
	   show_thread($r_in,$r_setup);
   }
	
}
elsif ($az eq "send_alert") {

	unless ($session) {
     $r_in->{'userdata'} = dcprotect($exurl,$password_file_dir,$r_in,
      \@login_fields,\%field_form_type);
	}

   print "\n";

   $heading = "Ihre Mitteilung wurde an den Administrator gesandt.";
   $sub_heading = "<B>Vieln Dank f&uuml;r Ihre Hilfe</B>";
   $html_output .= send_alert($r_in,$r_setup);
}
elsif ($az eq "printer_format") {

	printer_format($r_in,$r_setup);
   exit(0);
}
elsif ($az eq "alert") {

   print "\n";
   $heading = "Moderator eine Mitteilung zu diesem Beitrag senden.";
   $sub_heading = "<B>Vielen Dank f&uuml;r Ihre Bem&uuml;hungen dieses Forum sauber zu halten.</B>";
   $html_output = "Um Ihre Nachricht an den Moderator zu schicken m&uuml;ssen
   					Sie bereits ein registrierter Benutzer sein.";
   my $html_temp = alert($r_in,$r_setup);
   $html_output .= $html_temp;

}
elsif ($az eq "mark") {

	unless ($session) {
		$r_in->{'userdata'} = dcprotect($exurl,$password_file_dir,$r_in,
         \@login_fields,\%field_form_type);
	}
	mark_forum($r_in,$r_setup);
	print "Location: $boardurl\n\n";

	exit(0);

}
elsif ($az eq "search_form"){

   print "\n";

   $heading = "Suche in den Foren";
   $sub_heading = "Nach welchem Begriff soll gesucht werden?";
    $html_output =   create_search_form($r_in,$r_setup);
   $menu_button = create_button("search",$r_in,$r_setup);

}
elsif ($az eq "search"){

   if ($in{'check_private'} eq "yes" || 
         $r_setup->{'forum_type'}->{ $in{'s_forum'} } eq 'Private') {
      $r_in->{'userdata'} = dcprotect($exurl,$password_file_dir,$r_in,
         \@login_fields,\%field_form_type);
   }

   print "\n";

   $heading = "Ergebnis Ihrer Suche.";
   $sub_heading = "<hr size=\"1\">";
   $menu_button = create_button("search",$r_in,$r_setup);
   $html_output = search($r_in,$r_setup);
   $temp =  create_search_form($r_in,$r_setup);
   $html_output .= $temp;

}
elsif ($az eq "n_mesg") {

   print "\n";

   $heading = $heading_new_messages;
   $sub_heading = $sub_heading_new_messages;

   $menu_button = create_button("new_message",$r_in,$r_setup);
   $html_output = new_messages($r_in,$r_setup);

}
else {
	$heading = "DCForum99 Bulletin Board System<br>&copy; 1997-1999 <a href=\"http://www.dcscripts.com\">DCScripts</a>";
}

$html_forum_links = forum_links($r_in,$r_setup);

my %namespace = (
     FORUMLINKS => $html_forum_links,
     MENU => $menu_button,
     TITLE => $heading,
     HEADER => $heading,
     SUBHEADER => $sub_heading,
     HTMLOUTPUT => $html_output
);

display_output($templatefile,\%namespace);

exit(0);


####
#
# subroutine new_messages
# Lists New Messages in Last N days
#
####

sub new_messages {

   my ($r_in,$r_setup) = @_;
	my $table_heading;
	my $col_span;
   my $user_group = $r_in->{'userdata'}->{'Group'};

   my $html_output .= qq~
	<p><TABLE BORDER="0" CELLPADDING="2" WIDTH="$table_width">
	~;

   my $any_hits = "no";
   my $r_user_mark = get_user_mark($r_in,$r_setup);

	if ($r_setup->{'board_setup'}->{'display_caption'} eq "on") {
   	$table_heading = get_table_heading('main');
	}
	else {
   	$table_heading = get_table_heading();
	}

   foreach $forum (@{$r_setup->{'forums'}}) {
  
      my $hit = "no";
      my $html_new_mesg;
		my $f_ext;
      my $access = "no";
      my $last_mark = $r_in->{'last_read'};

  		toggle_color('reset');

      if ($r_user_mark->{$forum} ne "") {
         $last_mark = $r_user_mark->{$forum};
      }

      if ($r_setup->{'forum_type'}->{$forum} eq 'Private') {
         if ($user_group eq "admin" ||
                  $user_group eq "moderator" ||
                  $user_group eq "member") {
             $access = "yes";
             $fullpath = "$privatedir/$forum";
             $f_ext = $privateext;
         }
      }
      else {
         $fullpath = "$maindir/$forum";
         $access = "yes";
         $f_ext = $ext;
      }

      if ($r_setup->{'forum_status'}->{$forum} eq "on"  && $access eq "yes") {   

         my $r_rowdata = &readdata("$fullpath/$database");
    
         foreach (@$r_rowdata) {

            chomp;
# BIG5
#            my ($num,$date,$ltime,$name,$subject,$caption,$replies) = split(/::/, $_);
            my ($num,$date,$ltime,$name,$subject,$caption,$replies) = split(/\|/, $_);

		      if ($r_setup->{'board_setup'}->{'display_caption'} eq "on" && $caption ne "") {
		         $caption = "<br>$caption...";
					$caption = trim($caption);
# BIG5
#			   	$caption =~ s/&pip;/::/g;
			   	$caption =~ s/&pip;/\|/g;
					$col_span = 2;
		      }
		      else {
		         $caption = "";
					$col_span = 4;
		      }
		
            if (length($subject) > $subject_length_max) {
               $subject = substr($subject,0,$subject_length_max);
               $subject .= "...";
            }

            my ($hh,$minute,$second) = split(/\:/, $ltime);
            my ($mmonth,$dd,$yy) = split(/\//, $date);
            my $mesg_mark = compute_time($yy, $mmonth, $dd, $hh, $minute, $second);
    
            if ($mesg_mark > $last_mark ) {

					toggle_color();
               $hit = "yes";
               $html_new_mesg .=qq~
               <TR BGCOLOR="$bgcolor">
               <TD>
               <img src="$imgurl/folder.gif">~;

			      if ($r_setup->{'forum_type'}->{$forum} eq "Private") {
				        $html_new_mesg .=qq~
				           <FONT SIZE="$font_size" COLOR="$font_color" FACE="$font_face">
				            <a href="$exurl?az=show_thread&om=$num&forum=$forum"><b>$subject</b></a>
								$caption
				            </FONT></TD>
				         ~;
				   }
				   else {
				         $html_new_mesg .=qq~
				            <FONT SIZE="$font_size" COLOR="$font_color" FACE="$font_face">
				            <a href="$mainurl/$forum/$num\.$f_ext"><b>$subject</b></a>
								$caption</FONT>
				            </TD>
				         ~;
				   }

					$ltime = time_format($ltime);
					$date = date_format($date);
		
					if ($r_setup->{'board_setup'}->{'display_caption'} eq "on") {
				
				      $html_new_mesg .=qq~
				      <TD ALIGN="Left" VALIGN="TOP">
				         <FONT SIZE="$font_size" COLOR="$font_color" FACE="$font_face">
							<b>$name</b><br>
				         $date $ltime<br>
							<b>$replies</b> messages</FONT>
				      </TD>
				      </TR>
				      ~;
					}
					else {
				
				      $html_new_mesg .=qq~
				      <TD ALIGN="CENTER"  VALIGN="TOP"">
				         <FONT SIZE="$font_size" COLOR="$font_color" FACE="$font_face">$name</FONT></TD>      
				      <TD ALIGN="CENTER" VALIGN="TOP">
				         <FONT SIZE="$font_size" COLOR="$font_color" FACE="$font_face">$date $ltime</FONT>
				      </TD>
				      <TD ALIGN="CENTER" VALIGN="TOP">
				         <FONT SIZE="$font_size" COLOR="$font_color" FACE="$font_face">$replies</FONT>
				      </TD>
				      </TR>
				      ~;
					}

             }

            else {
               last;
            }

         } #END of foreach

      } #END of if

      if ($hit eq "yes") {
         $any_hits = "yes";
         $html_output .=qq~
         <TR><TH ALIGN="CENTER" COLSPAN="$col_span" BGCOLOR="$bg_color_0">
			<FONT SIZE="3" COLOR="$font_color_0" FACE="$font_face_0">
         New Messages in $r_setup->{'forum_name'}->{$forum} Forum
			</FONT></TD></TR>
         ~;
         $html_output .= $table_heading;
         $html_output .= $html_new_mesg;
      }

   } # END OF EACH FORUM
   
   if ($any_hits eq "no") {
       $html_output .=qq~
         <TR><TH ALIGN="CENTER" COLSPAN="4" BGCOLOR="$bg_color_0">
			<FONT SIZE="3" COLOR="$font_color_0" FACE="$font_face_0">
         There were no new messages posted in last $r_in->{'days'} days.
			</FONT/>
         </TH></TR>
     ~;
   }

   $html_output .= "</TABLE>\n";  
     
}


###
### subroutine alert
###

sub alert {

   my ($r_in,$r_setup) = @_;

	my ($omm,$level,$subject,$name,$email,$ltime,$date,$body) = 
			get_record("$maindir/$forum/$thread_dir/$r_in->{'om'}.$thread_ext",$r_in->{'omm'});
	my $bad_link;
   my $html_output;

# Read in the message information

   $body =~ s/<p>/\n\n/gi;
   $body =~ s/<br>/\n/gi;
   $body =~ s/<([^>]|\n)*>//g;

	
   if ($r_setup->{'forum_type'}->{$forum} eq "Private") {
        $bad_link = "$exurl?az=show_thread&om=$r_in->{'om'}&forum=$forum";
   }
   else {
         $bad_link = "$mainurl/$forum/$r_in->{'om'}.$ext#$r_in->{'omm'}";
   }

   $html_output .= qq~
   <p align="left">
   <form method="post">
   <FONT SIZE="3">
  You have selected following message to alert the administrator and the moderator
  of this forum.
  <p align="left">

<textarea name="alert_message" rows="12" cols="60" readonly>Message Information:
----------------------------------------------------
Forum: $r_setup->{'forum_name'}->{$forum}
Beitragsnummer: $r_in->{'om'}
Antwort Nummer: $omm (0 = original message)
Thema des Beitrags: $subject
Geschrieben von: $name
Geschrieben am: $ltime, $date
----------------------------------------------------
Beitragstext:
----------------------------------------------------
$body
----------------------------------------------------
Link des Beitrags:
----------------------------------------------------
$bad_link
----------------------------------------------------</textarea>

   <p align="left">
   Bitte nennen Sie den Grund warum dieser Beitrag gel&ouml;scht werden soll:
   </FONT>
   <br>
   <textarea name="reason" rows="4" cols="60" wrap="physical"></textarea>
   <input type="hidden" name="om" value="$om">
   <input type="hidden" name="omm" value="$omm">
   <input type="hidden" name="forum" value="$forum">
   <input type="hidden" name="az" value="send_alert">
   <p align="left">
   <h3 align="left">Klicken Sie auf Absenden um die Warnung zu senden</h3>
   <input type="submit" value="Absenden">
   </FORM>
   ~;

   $html_output;  
}  

####
#
#  subroutine send_alert
# Sends an alert email to admin
#
####

sub send_alert {

   my ($r_in,$r_setup) = @_;
   my $html_output;
   my $moderator_email = $r_setup->{'forum_owner_email'}->{$forum};

   my $username = $r_in->{'userdata'}->{'Username'};

	$r_in->{'alert_message'} =~ s/<p>/\n\n/gi;
	$r_in->{'alert_message'} =~ s/<br>/\n/gi;
	$r_in->{'alert_message'} =~ s/&gt;/>/gi;
   
   my $mail_output .= qq~  
Der Benutzer $username hat folgende Warnung geschrieben:
----------------------------------------------------
$r_in->{'alert_message'}
----------------------------------------------------
$username's Comment/Reason:
----------------------------------------------------
$r_in->{'reason'}
~;

   my $r_auth = {};
   get_setup_variables("$password_file_dir/$auth_setup_file",$r_auth);

   send_mail($password_file_dir,$r_auth->{'Sendmail Path'},
            $r_auth->{'Admin EMail Address'},
            $r_auth->{'Admin EMail Address'},
            "BAD MESSAGE ALERT from $username",$mail_output );

	if ($moderator_email) {
   	send_mail( $password_file_dir,$r_auth->{'Sendmail Path'},
            $r_auth->{'Admin EMail Address'},
            $moderator_email,
            "BAD MESSAGE ALERT from $username",$mail_output );
	}

   $html_output .= "<h3 align=center>[ <a href=\"$boardurl\">Zur&uuml;ck zur &Uuml;bersicht</a> ]</h3>\n";

}


####
#
# subroutine mark_forum
# Marks a given forum
#
####

sub mark_forum {

   my ($r_in, $r_setup) = @_;

   my $time_mark = $r_in->{'time_now'};
   my $exist = "";
   my $user_file = "$password_file_dir/$r_in->{'userdata'}->{'Username'}\.log";
   my @start;
   my @rows;

   # initialize an array of forum name and some
   # arbitrary number which will be saved if the user clicked on
   # Mark icon for the first time

   foreach (@{$r_setup->{'forums'}}) {
      my $temp = join("=",$_,"1000");
      push(@start,"$temp\n")
   }

   # Check and see if the log file exist
   # If it doesn't create one

   check_datafile($user_file,\@start);
   $r_rows = readdata_nolock($user_file);
   if ($forum eq "all") {
      foreach (@{$r_setup->{'forums'}}) {
         my $temp = join("=",$_,$time_mark);
         push(@rows,"$temp\n")
      }
   }
   else {
      foreach $pair (@{$r_rows}) {
         chomp($pair);
         my ($forum_name,$lastread) = split(/=/,$pair);
         if ($forum_name eq $forum) {
            $exist = "yes";
            $temp = join("=",$forum,$time_mark);
            push(@rows,"$temp\n");
         }
         else {
            push(@rows,"$pair\n");
         }

    }

      unless ($exist) {
         $temp = join("=",$forum,$time_mark);
         push(@rows,"$temp\n");
      }

   }

   writedata($user_file,\@rows);

}


####
#
# sub create search form
####

sub create_search_form {

   my ($r_in,$r_setup) = @_;

	my @search_day = qw(1 2 3 4 7 14 30 90 365);
	my %search_days = (
	   1=>"Bis gestern",
	   2=>"Bis vorgestern",
	   3=>"In den letzten 3 Tage",
	   4=>"In den letzten 4 Tage",
	   7=>"In der letzte Woche",
	   14=>"In den letzten 2 Wochen",
	   30=>"Im letzten Monat",
	   90=>"In den letzten 3 Monate",
	   365=>"Im letzten Jahr"
	);

	my @search_fields = qw(
	   Alle
	   Autor
	   Thema
	   Beitrag
	);

   my $html_output .=qq~
		<center>
		<table border="0" cellpadding="2" WIDTH="$table_width">
		<tr><th align="right" bgcolor="$bg_color_3"><FONT SIZE="$font_size_3" 
		FACE="$font_face_3" color="$font_color_3"><FORM METHOD="POST">
		<INPUT TYPE="HIDDEN" NAME="az" VALUE="search">
		Suchbegriff(e):</th><td bgcolor="$bg_color_3">
		<INPUT TYPE="TEXT" SIZE="30" NAME="keywords" value="$r_in->{'keywords'}">
		</td></tr>~;

		toggle_color();
		$html_output .=qq~
		<tr><th align="right" bgcolor="$bg_color_3">
		<FONT SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
		<b>*</b>In welchen Foren?
		</font>
		</th>
		<td bgcolor="$bg_color_3">
		<FONT SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
		<SELECT NAME="s_forum">~;

      foreach (@{$r_setup->{'forums'}}) {

			my $display = 'yes';
			if ($r_setup->{'forum_type'}->{$_} eq 'Private') {
		   	$display = "no";
				if ($r_in->{'userdata'}->{'Group'} eq "admin" or
						$r_in->{'userdata'}->{'Forums'} =~ /$_/) {
		    		$display = "yes";
		   	}
			}

			if ($display eq 'yes') {
         	if ($_ eq $r_in->{'s_forum'}) {
               $html_output .=qq~
           		<option VALUE="$_" selected>$r_setup->{'forum_name'}->{$_} ($r_setup->{'forum_type'}->{$_})
            	~;
             }
             else {
             	$html_output .=qq~
           		<option VALUE="$_">$r_setup->{'forum_name'}->{$_} ($r_setup->{'forum_type'}->{$_})
            	~;
            }
			}
       }

            if ($r_in->{'s_forum'} eq "all") {
            $html_output .=qq~
            <OPTION VALUE="all" selected>Alle Foren durchsuchen~;
            }
            else {
            $html_output .=qq~
            <OPTION VALUE="all">Alle Foren durchsuchen~;
            }

       $html_output .=qq~
      </SELECT>         
         </td>
         </tr>~;
			
		toggle_color();
		$html_output .=qq~
         <tr>
		<th align="right" bgcolor="$bg_color_3">
		<FONT SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
         In bestimmten Feldern suchen?
      </font>
         </th>
		<td bgcolor="$bg_color_3">
		<FONT SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
         <select name="fields">~;
       foreach (@search_fields) {
           if ($_ eq $r_in->{'fields'}) {
             $html_output .=qq~
             <option VALUE="$_" selected>$_
             ~;
           }
           else {
             $html_output .=qq~
             <option VALUE="$_">$_
            ~;
           }
      }

             $html_output .=qq~
         </select>
         </td>
         </tr>~;
			
		toggle_color();
		$html_output .=qq~
         <tr>
		<th align="right" bgcolor="$bg_color_3">
		<FONT SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
         <b>**</b>In einem bestimmten Zeitraum suchen?
      </font>
         </th>
		<td bgcolor="$bg_color_3">
		<FONT SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
         <select name="days">~;

       foreach (@search_day) {
           if ($_ eq $r_in->{'days'}) {
             $html_output .=qq~
             <option VALUE="$_" selected>$search_days{$_}
             ~;
           }
           else {
             $html_output .=qq~
             <option VALUE="$_">$search_days{$_}
            ~;
           }
      }

      $html_output .=qq~
         </select>
         </td>
         </tr>~;
			
		toggle_color();
		$html_output .=qq~
         <tr>
		<th align="right" bgcolor="$bg_color_3">
		<FONT SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
         Im Archiv suchen?
      </font>
         </th>
		<td bgcolor="$bg_color_3">
		<FONT SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">~;
		         
         if ($r_in->{'arc_database'}) {
          $html_output .=qq~
            <input type="checkbox" name="arc_database" value"not_empty" checked>~;
         }
         else {
        $html_output .=qq~
            <input type="checkbox" name="arc_database" value"not_empty">~;
         }

       $html_output .=qq~
         </td>
         </tr>~;
			
		toggle_color();
		$html_output .=qq~
         <tr>
		<td bgcolor="$bg_color_3">
		&nbsp;
		</td>
		<td bgcolor="$bg_color_3">
		<FONT SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
		<INPUT TYPE="SUBMIT" VALUE="Suche starten">
		<INPUT TYPE="RESET" VALUE="Reset">
      </FORM>
         </td>
         </tr>~;
			
		toggle_color();
		$html_output .=qq~
         <tr>
		<td bgcolor="$bg_color_3" colspan="2">
		<FONT SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
         <b>*</b>Die Suche in allen Foren kann einen Moment dauern.
         <br>
         <b>**</b>Die Suche in allen Beitr&auml;gen kann einen Moment dauern.
         <br>
	      </font>
         </td>
         </TR>
         </TABLE>
      </center>
      <P>~;   

      $html_output;
}


################################################################
#
# subroutine search
# performs keyword search
# based on search_engine.cgi written by Gunther Berznieks
#
###############################################################

sub search {

   my ($r_in,$r_setup) = @_;

   my $user_group = $r_in->{'userdata'}->{'Group'};
   my $last_read = $r_in->{'last_read'};
   my $html_output;
   my $exact_match = "off";
   my $keywords = $r_in->{'keywords'};
   my @keyword_list = split(/\s+/,$keywords);
	my $search_field = $r_in->{'fields'};

   my $table_heading;
	if ($r_setup->{'board_setup'}->{'display_caption'} eq "on") {
   	$table_heading = get_table_heading('main');
	}
	else {
   	$table_heading = get_table_heading();
	}

   if ($r_in->{'arc_database'}) {
      $database = "arc_$database";
   }

   if ($keywords eq "") {
      display_status("No Keywords",$r_in,$r_setup);
      exit(0);
   }

   my $number_of_hits = 0;

   if ($r_in->{'s_forum'} eq "all" ) {
      @forums = @{ $r_setup->{'forums'} };
   }
   else {
      @forums = ("$r_in->{'s_forum'}");
   }

   $html_output .=qq~
      <TABLE BORDER="0" CELLPADDING="2" WIDTH="$table_width">
   ~;
    
   foreach (@forums) {
  
      my $forum = $_;
      my $topdir;
      my $topurl;

      my $hit = "no";
      my $html_new_mesg = "";
      my $access = "yes";
   
		#Search only the forums that users are allowed to access

		if ($r_setup->{'forum_type'}->{$_} eq 'Private') {
		   	$access = "no";
				if ($r_in->{'userdata'}->{'Group'} eq "admin" or
						$r_in->{'userdata'}->{'Forums'} =~ /$_/) {
		    		$access = "yes";
					$topdir = "$privatedir/$forum";
		   	}
      }
      else {
         $access = "yes";
         $topdir = "$maindir/$forum";
         $topurl = "$mainurl/$forum";
      }

		
      if ($r_setup->{'forum_status'}->{$forum} eq "on"  && $access eq "yes") {   

         my $r_forum_data = readdata("$topdir/$database");
         my $forum_number_of_hits = 0;
   
         foreach (@$r_forum_data) {

# BIG5
#      	my ($num,$date,$ltime,$name,$subject,$caption,$replies) = split(/::/, $_);
      	my ($num,$date,$ltime,$name,$subject,$caption,$replies) = split(/\|/, $_);

		      if ($r_setup->{'board_setup'}->{'display_caption'} eq "on" && $caption ne "") {
		         $caption = "<br>$caption...";
					$caption = trim($caption);
# BIG5
#			   	$caption =~ s/&pip;/::/g;
			   	$caption =~ s/&pip;/\|/g;
					$col_span = 2;
		      }
		      else {
		         $caption = "";
					$col_span = 4;
		      }
		
            if (length($subject) > $subject_length_max) {
               $subject = substr($subject,0,$subject_length_max);
               $subject .= "...";
            }

            my ($hh,$minute,$second) = split(/\:/, $localtime);
            my ($mmonth,$dd,$yy) = split(/\//, $date);
				$yy += 1900 if ($yy < 100);
            my $mesg_mark = compute_time($yy, $mmonth, $dd, $hh, $minute, $second);
  
            unless ($mesg_mark > $last_read ) {
					unless ($r_in->{'arc_database'}) {
               	last;
					}
            }
            else {
   
	            my $are_we_in_head = 0;
	            my $filename = "$num";
	
	            $fullpath = "$topdir/$thread_dir/$filename.$thread_ext";
	   
	            @not_found_words = @keyword_list; 
	   
	            unless (open(SEARCHFILE, $fullpath)) {
					   next;
	            }
	            else {
   
               while(<SEARCHFILE>) {
						chomp;
# BIG5
#					   my ($omm,$level,$subject,$name,$email,$ltime,$date,$body) = split /::/;
					   my ($omm,$level,$subject,$name,$email,$ltime,$date,$body) = split /\|/;
						my $string;

						if ($search_field eq "Author") {
							$string = $name;
						}
						elsif ($search_field eq "Subject") {
							$string = $subject;
						}
						elsif ($search_field eq "Message") {
							$string = $body;
						}
						else {
							$string = $subject . $name . $body;
						}

	               FindKeywords($exact_match, $string, *not_found_words);

               } # End of SEARCHFILE
   
               close (SEARCHFILE);
 
               if (@not_found_words < 1) {
  						toggle_color();
                  $forum_number_of_hits++;
                  $number_of_hits++;
                  if ($forum_number_of_hits == 1) {
                  	$html_output .= qq~
                  	<tr>
	                  <th colspan="$col_span" bgcolor="$bg_color_0" align="center">
	                  <FONT COLOR="$font_color_0" FACE="font_face_0" SIZE="4">
	                  Treffer im Forum "$r_setup->{'forum_name'}->{$forum}"
							</FONT>
	                  </th>
	                  </tr>
	                  ~;
	                  $html_output .= $table_heading;
	               }
   
	               $hit = "yes";
	               $html_output .=qq~
	               <TR BGCOLOR="$bg_color_3">
	               <TD>
	               <img src="$imgurl/folder.gif">~;
	
				      if ($r_setup->{'forum_type'}->{$forum} eq "Private") {
					        $html_output .=qq~
					           <FONT SIZE="$font_size_3" COLOR="$font_color_3" FACE="$font_face_3">
					            <a href="$exurl?az=show_thread&om=$num&forum=$forum"><b>$subject</b></a>
									$caption
					            </FONT></TD>
					         ~;
					   }
					   else {
					         $html_output .=qq~
					            <FONT SIZE="$font_size_3" COLOR="$font_color_3" FACE="$font_face_3">
					            <a href="$mainurl/$forum/$num\.$ext"><b>$subject</b></a>
									$caption</FONT>
					            </TD>
					         ~;
					   }
	
						my $ltime = time_format($localtime);
						my $ldate = date_format($date);
			
						if ($r_setup->{'board_setup'}->{'display_caption'} eq "on") {
					
					      $html_output .=qq~
					      <TD ALIGN="Left" VALIGN="TOP">
					         <FONT SIZE="$font_size_3" COLOR="$font_color_3" FACE="$font_face_3">
								<b>$name</b><br>
					         $ldate $ltime<br>
								<b>$replies</b> messages</FONT>
					      </TD>
					      </TR>
					      ~;
						}
						else {
					
					      $html_output .=qq~
					      <TD ALIGN="CENTER"  VALIGN="TOP"">
					         <FONT SIZE="$font_size_3" COLOR="$font_color_3" FACE="$font_face_3">$name</FONT></TD>      
					      <TD ALIGN="CENTER" VALIGN="TOP">
					         <FONT SIZE="$font_size_3" COLOR="$font_color_3" FACE="$font_face_3">$ldate $ltime</FONT>
					      </TD>
					      <TD ALIGN="CENTER" VALIGN="TOP">
					         <FONT SIZE="$font_size_3" COLOR="$font_color_3" FACE="$font_face_3">$replies</FONT>
					      </TD>
					      </TR>
					      ~;
						}
	
	            } # If there are no not_found_words
	
	         } # unless
	           
	      } # If message is within last n days
	
	   } # If access - yes
   
   } # Foreach file

	} #Foreach forum
  
  if ($number_of_hits == 0) {
    &display_status("Kein Treffer",$r_in,$r_setup);
  }
  
  $html_output .= "</table><hr size=2>\n";
  
} # End of Search Subroutine


####
# subroutine FindKeyWords
# Written By Gunther Berzenik
####

sub FindKeywords {

   local ($exact_match, $line, *not_found_words) = @_;
   my ($x, $match_word);

   if ($exact_match eq "on") {
      for ($x = @not_found_words; $x > 0; $x--) {
         $match_word = $not_found_words[$x - 1];
         if ($line =~ /\b$match_word\b/i) {
            splice(@not_found_words,$x - 1, 1);
         } # End of If
      } # End of For Loop
   }
   else {
      for ($x = @not_found_words; $x > 0; $x--) {
         $match_word = $not_found_words[$x - 1];
         if ($line =~ /$match_word/i) {
            splice(@not_found_words,$x - 1, 1);
         } # End of If
      } # End of For Loop
   } # End of ELSE

} # End of FindKeywords

####
#
# subroutine printer_format
# displays a page that is print friendly
#
####

sub printer_format {

   my ($r_in,$r_setup) = @_;
   my $mesg;

	print "\n";
	print "<html><head></head><body color=\"#FFFFFF\">\n";
   print qq~
	<font size="2">
	<b>
	URL: $boardurl<br>
	Forum: $forum<br>
	Thread Number: $r_in->{'om'}<br>
	[ <a href="$ENV{'HTTP_REFERER'}">Zur&uuml;ck zur vorigen Seite</a> ]
	</b><hr>
	~;

	my $r_thread = readdata("$maindir/$forum/$thread_dir/$r_in->{'om'}.$thread_ext");
	shift(@$r_thread);

	my $prev_level = 0;
	my $ul_count = 0;
	foreach (@$r_thread) {
		chomp;

# BIG5
#		my ($omm,$level,$subject,$name,$email,$ltime,$date,$body) = split /::/;
#		$body =~ s/&pip;/::/g;
#		$subject =~ s/&pip;/::/g;

		my ($omm,$level,$subject,$name,$email,$ltime,$date,$body) = split /\|/;
		$body =~ s/&pip;/\|/g;
		$subject =~ s/&pip;/\|/g;
		
		$ltime = time_format($ltime);
 		$date = date_format($date);
		if ($email) {
				$email = remove_antispam($email);
				$email = "[$email]";
		}

		if ($omm == 0) {
			print qq~
			<b><font size=3>Original Beitrag<hr>"$subject"</font></b><br>
			geschrieben von $name $email am $data at $ltime<br>
			<blockquote>
			$body
			</blockquote>
			<hr>
			~;
		}
		else {
			$mesg .= qq~
			<b><font size=3>"$subject"</font></b><br>
			Geschrieben von $name $email am $data at $ltime<br>
			<blockquote>
			$body
			</blockquote>
			<hr>
			~;

			if ($level > $prev_level) {
				for ($j=0;$j<$level-$prev_level;$j++) {
					$toc .= "<ul>\n";
					$ul_count++;
				}
			}
			elsif ($level < $prev_level) {
				for ($j=0;$j<$prev_level-$level;$j++) {
					$toc .= "</ul>\n";
					$ul_count--;
				}
			}

			$prev_level = $level;
  		   $toc .= qq~
      	  <li><b>$subject</b>,<b>$name</b>, $ltime, $date
      	~;
		}
	}

	for ($j=0;$j<$ul_count;$j++) {
		$toc .= "</ul>\n";
	}

	print "<b><font size=3>&Uuml;bersicht</font></b><hr>\n";
	print "$toc\n";
	print "<hr><b><font size=3>Beitr&auml;ge in dieser Diskussion</font></b><hr>\n";
   print "$mesg\n";
	print "</font></body></html>\n";
	exit(0);

}
