# dcforumlib2.pl
# Part of DCForum99 by DCScripts
# Contains common functions used by various dcscripts
#
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCForum.
# You should carefully read this terms agreement as outlined in
# the readme.txt file included with this distribution before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
###################################################################
##  German translation by Lothar Jung for Webster Internet Dienstleistungen
##  http://Webster.de/dcscripts/
###################################################################


#>>>>>>>>>>>>>>> Keine &Auml;nderungen in diesem Script erforderlich <<<<<<<<


#######
# subroutine create_thread
# creates a new thread database file
#######

sub create_thread {
   my ($r_in,$r_setup) = @_;
   my @text;
	push(@text,"0\n");
# BIG5
#   push(@text,"0::0::$r_in->{'subject'}::$r_in->{'name'}::$r_in->{'email'}::$r_in->{'localtime'}::$r_in->{'date'}::$r_in->{'body'}\n");
   push(@text,"0\|0\|$r_in->{'subject'}\|$r_in->{'name'}\|$r_in->{'email'}\|$r_in->{'localtime'}\|$r_in->{'date'}\|$r_in->{'body'}\n");
   writedata("$maindir/$forum/$thread_dir/$r_in->{'om'}.$thread_ext",\@text);
}

####
# subroutine create_message
# Based on thread database in $maindir/$forum/$thread_dir/thread.txt
# and on dcforum.htmlt and other setup parameters,
# create thread.html file
###

sub create_message {

   my ($r_in,$r_setup) = @_;

	# Local variables

	my $dir, $extension;
	my $table_of_contents ='';
   my $html_output = '';
	my $html_main_body = '';
	my $html_orig_body = '';
	my $r_row, $r_rowdata, $num_messages, $last_few_messages;
	my $heading = '';
	my $sub_heading = '';
	my $main_lobby = '';

	# Forum link

   my $html_forum_links = '';

	unless ($r_in->{'html_forum_link'}) {
		$html_forum_links = forum_links($r_in,$r_setup);
	}

	# Menu button Icons
   my $menu_button = create_button("message",$r_in,$r_setup);

	# If forum typs is Private then set proper path and file extension
	if ($r_setup->{'forum_type'}->{$forum} eq "Private") {
		$dir = $privatedir;
		$extension = $privateext;
	}
	else {
		$dir = $maindir;
		$extension = $ext;
	}

	# Read in from thread.txt database
   $r_rowdata = readdata("$dir/$forum/$thread_dir/$r_in->{'om'}.$thread_ext");

	# First line contains next message number
	# don't needed for creating thread.html
	shift(@{$r_rowdata}); # shift our first line

	# Number of messages and last few messages
	$num_messages = @{$r_rowdata} - 1;
	$last_few_messages = $num_messages - int($num_messages/5);

	$table_of_contents = "<h3 align=center>Keine Beitraege!</h3>" if ($num_messages < 1);

	# Ready to create thread.html	
	# $r_row is a reference to a hash whose values are
   # reference to an array whose elements are fields of
   # each message

	$r_row = {};

	foreach (@{$r_rowdata}) {
		chomp;
# BIG5
#		my @temp = split /::/;
		my @temp = split /\|/;
		$r_row->{$temp[0]} = \@temp;
	}

	# Create main-lobby icons
   # they will be placed at the botton of table of contents
	if (-e "$imgdir/left_e.gif") {
		$main_lobby .= qq~<IMG 
		SRC="$imgurl/left_e.gif" BORDER="0">~;
	}

   $main_lobby .= qq~<a 
	   href="$boardurl?az=list&forum=$forum"><IMG 
		SRC="$imgurl/home.gif" BORDER="0" 
		alt="Klicken Sie hier zum \"$forum\" Forum"></a><a 
		href="$boardurl"><IMG SRC="$imgurl/mainforum.gif" BORDER="0" 
		alt="Klicken Sie hier um zu Lobby zu gelangen"></a>~;

	if (-e "$imgdir/right_e.gif") {
		$main_lobby .= qq~<IMG 
		SRC="$imgurl/right_e.gif" BORDER="0">~;
	}


	# Next read in the team members
	my $r_team = [];
	if (-e "$password_file_dir/$team_file_name") {
		$r_team = readdata("$password_file_dir/$team_file_name");
	}	
	my $team = join(" ",@{$r_team});

	# First, if fully threaded dicussion, then thread it.
	if ($r_setup->{'board_setup'}->{'threaded_discussion'} eq 'on') {

		my $prev_level = 0;
		my $ul_count = 0;

		foreach (@{$r_rowdata}) {

# BIG5
#			my ($omm,$level,$subject,$name,$email,$ltime,$date,$body) = split /::/;			
			my ($omm,$level,$subject,$name,$email,$ltime,$date,$body) = split /\|/;			
	      $r_in->{'omm'} = $omm;
	      $r_in->{'level'} = $level;
			$r_in->{'subject'} = $subject;
	      $r_in->{'name'} = $name;
	      $r_in->{'email'} = $email;
	      $r_in->{'ltime'} = $ltime;
	      $r_in->{'date'} = $date;
	      $r_in->{'body'} = $body;

# BIG5
#			$r_in->{'body'} =~ s/&pip;/::/g;
#			$r_in->{'subject'} =~ s/&pip;/::/g;

			$r_in->{'body'} =~ s/&pip;/\|/g;
			$r_in->{'subject'} =~ s/&pip;/\|/g;
	
			$ltime = time_format($ltime);
	 		$date = date_format($date);

		   if (length($subject) > $subject_length_max) {
	   	   $subject = substr($subject,0,$subject_length_max);
	      	$subject .= "...";
	   	}

			if ($team =~ /\b$name\b/) {
				$name .= $team_name;
			}

			# See if it's original, level 1 reply, or others
			
			if ($omm == 0) {
				$r_in->{'indent'} = "";
				$html_orig_body .= html_main_body($r_in,$r_setup);
				$heading = "\"$r_in->{'subject'}\"";
			}
			elsif ($level == 1) {

				if ($r_setup->{'board_setup'}->{'use_icons_toc'} eq 'on') {
					$table_of_contents .= qq~
					<img src="$imgurl/folder.gif">
					<a href="#$r_in->{'omm'}">$subject</a>,
					<b>$name</b>, <font size="1">$date, ($r_in->{'omm'})</font><br>
					~;
				}
				else {

					if ($level > $prev_level) {
						for ($j=0;$j<$level-$prev_level;$j++) {
							$table_of_contents .= "<ul>\n";
							$ul_count++;
						}
					}
					elsif ($level < $prev_level) {
						for ($j=0;$j<$prev_level-$level;$j++) {
							$table_of_contents .= "</ul>\n";
							$ul_count--;
						}
					}

					$prev_level = $level;
        	     	$table_of_contents .= qq~
              	<li><a href="#$r_in->{'omm'}">$subject</a>,
              	<b>$name</b>, <font size="1">$ltime, $date</font>
              	~;
				}

				$r_in->{'indent'} = "";
				$html_main_body .= html_main_body($r_in,$r_setup);
			}
			else {
	
				my $icon = "file.gif";
				$icon = "last_file.gif" if ($omm > $last_few_messages);
				my $space = ($level-2)*$level_spacing + 1;

				$r_in->{'indent'} = 18*($level-1);

				if ($r_setup->{'board_setup'}->{'use_icons_toc'} eq 'on') {
					$table_of_contents .= qq~
					<img src=\"$imgurl/blank.gif\" width=\"$space\" height=\"14\"><img 
					src=\"$imgurl/$icon\"> <a 
					href=\"\#$r_in->{'omm'}\">$subject</a>,
					<b>$name</b>, <font size="1">$date, ($r_in->{'omm'})</font><br>
					~;
				}
				else {

					if ($level > $prev_level) {
						for ($j=0;$j<$level-$prev_level;$j++) {
							$table_of_contents .= "<ul>\n";
							$ul_count++;
						}
					}
					elsif ($level < $prev_level) {
						for ($j=0;$j<$prev_level-$level;$j++) {
							$table_of_contents .= "</ul>\n";
							$ul_count--;
						}
					}

					$prev_level = $level;
        	     	$table_of_contents .= qq~
              	<li><a href="#$r_in->{'omm'}">$subject</a>,
              	<b>$name</b>, <font size="1">$ltime, $date</font>
              	~;
				}

				$html_main_body .= html_main_body($r_in,$r_setup);
			}

		}

		for ($j=0;$j<$ul_count;$j++) {
			$table_of_contents .= "</ul>\n";
		}

		$html_output .= qq~
		<TABLE BORDER="0" WIDTH="$table_width" cellspacing="0" cellpadding="3">
		<TR><TD ALIGN="RIGHT">
		<font SIZE="1" FACE="$font_face_3" color="$font_color_3">
		<b>$r_setup->{'forum_name'}->{$forum}</b><br>
		Forum Typ: $r_setup->{'forum_type'}->{$forum}<br>
   	Moderator: <a href="mailto:$r_setup->{'forum_owner_email'}->{$forum}">
			$r_setup->{'forum_owner'}->{$forum}</a><br>
		Time Zone: $time_zone
		</font></TD></TR>
		<TR><TD ALIGN="LEFT">
		<font SIZE="1" FACE="$font_face_3" color="$font_color_3">
		<a href="$exurl?az=printer_format&om=$r_in->{'om'}&forum=$forum"><b>Druckfaehiges Format</b></a>
		</font></TD></TR>
		<TR BGCOLOR="$bg_color_0">
		<TH ALIGN="LEFT">
		<font SIZE="3" FACE="$font_face_0" color="$font_color_0">
		Original Beitrag</font></TH></TR></TABLE>
		$html_orig_body
		<br>
		<TABLE BORDER="0" WIDTH="$table_width" cellspacing="0" cellpadding="3">
		<TR BGCOLOR="$bg_color_0">
		<TH ALIGN="LEFT">
		<font SIZE="3" FACE="$font_face_0" color="$font_color_0">
		<a name="TOP">&nbsp;</a>&Uuml;bersicht der Antworten
		</font></TH>
		</TR></TABLE>
		<br>
		<TABLE BORDER="0" WIDTH="$table_width" cellspacing="0" cellpadding="0">
		<TR><TD ALIGN="LEFT" COLSPAN="2">
		<font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
		$table_of_contents
		</font></TD></TR></TABLE>		
		<p>&nbsp;<p>&nbsp;
		<TABLE BORDER="0" WIDTH="$table_width" cellspacing="0" cellpadding="0">
		<TR><TD ALIGN="right" COLSPAN="2">
		$main_lobby
		</TD></TR></TABLE>
		<TABLE BORDER="0" WIDTH="$table_width" cellspacing="0" cellpadding="3">
		<TR BGCOLOR="$bg_color_0">
		<TH ALIGN="LEFT">
		<font SIZE="3" FACE="$font_face_0" color="$font_color_0">
		Beitraege in dieser Diskussion
		</font></TH>
		</TR></TABLE>
		~;

	}
	else {

		foreach (sort {$a <=> $b} keys %{$r_row}) {
			my ($omm,$level,$subject,$name,$email,$ltime,$date,$body) = @{$r_row->{$_}};
	      $r_in->{'omm'} = $omm;
	      $r_in->{'level'} = $level;
	      $r_in->{'subject'} = $subject;
	      $r_in->{'name'} = $name;
	      $r_in->{'email'} = $email;
	      $r_in->{'ltime'} = $ltime;
	      $r_in->{'date'} = $date;
	      $r_in->{'body'} = $body;

			if ($omm ==0) {
				$heading = "\"$r_in->{'subject'}\"";
			}
			$html_main_body .= html_main_body($r_in,$r_setup);

		}
	}

	$html_output .= qq~
	$html_main_body
	<TABLE BORDER="0" WIDTH="$table_width">
	<TR><TD ALIGN="LEFT">
	<BR>
	<br>
	~;
	
	if (-e "$imgdir/left_e.gif") {
		$html_output .= qq~<IMG 
		SRC="$imgurl/left_e.gif" BORDER="0">~;
	}
		
	$html_output .= qq~<a 
	href="$adminurl?az=remove_threads&now_what=archive&forum=$forum&selected=$r_in->{'om'}"><IMG 
		SRC="$imgurl/archive.gif" BORDER="0" ALT="Beitrag(Thread) archivieren: Nur fuer den Admin/Moderator"></a><a 
		href="$adminurl?az=remove_threads&now_what=remove&forum=$forum&selected=$r_in->{'om'}"><IMG
		SRC="$imgurl/remove.gif" BORDER="0"  ALT="Beitrag(Thread) loeschen: Nur fuer den Admin/Moderator"></a>~;

	if (-e "$imgdir/right_e.gif") {
		$html_output .= qq~<IMG 
		SRC="$imgurl/right_e.gif" BORDER="0">~;
	}

	$html_output .= qq~
	<br>
	</TD><TD ALIGN="RIGHT">
	$main_lobby
	</TD></TR></TABLE>
	~;

  my $title = $heading;
  
  my $httpheader .= qq~
<META HTTP-EQUIV="Expires" CONTENT="Tues, 04 Dec 1996 21:00:00 GMT">
<META HTTP-EQUIV="pragma" content="no cache">~;

  my %namespace = (
     FORUMLINKS => $html_forum_links,
     MENU => $menu_button,
     HTTPHEADER => $httpheader,
     TITLE => $title,
     HEADER => $heading,
     SUBHEADER => $sub_heading,
     HTMLOUTPUT => $html_output
  );

  my $html_file = return_output($templatefile,\%namespace);
  my @html_file;
  $html_file[0] = $html_file;
  writedata("$dir/$forum/$r_in->{'om'}\.$extension",\@html_file);

}


#####
#
# subroutine html_main_body
# generates the message table
#
####

sub html_main_body {

   my ($r_in,$r_setup) = @_;

	my $icon_text = '';	
	my $omm = $r_in->{'omm'};
	my $text_omm = "$omm . " if ($omm);
	my $font_size = $font_size_1;

	my $this_time = time_format($r_in->{'ltime'});
	my $this_date = date_format($r_in->{'date'});

	my $profile_name = '';
	my $profile_icon = '';

	if (-e "$password_file_dir/$profile_dir/$r_in->{'name'}.$profile_ext") {
		$profile_name = qq~<a href="$dcuser?az=show_profile&user=$r_in->{'name'}">USER PROFIL</a>~;
		$profile_icon = qq~<a href="$dcuser?az=show_profile&user=$r_in->{'name'}"><img
			src="$imgurl/profile.gif" border="0"></a>~;
	}
	
  	my $html_main_body .= qq~
	<a name="$omm">&nbsp;</a>
  	<TABLE BORDER="0" WIDTH="$table_width" CELLPADDING="4" Cellspacing="0">
	~;
	
	if ($r_in->{'indent'} && $r_setup->{'board_setup'}->{'message_indent'} eq 'on') {
  		 $html_main_body .= qq~
			<tr>
			<td rowspan="4" width="$r_in->{'indent'}">
			<img src="$imgurl/blank.gif" width="$r_in->{'indent'}" height="10">
			</td>
			</tr>
			~;
	}

  	$html_main_body .= qq~	
      <TR BGCOLOR="$bg_color_2"><TD align="left" colspan="2" width="100%">
      	<FONT SIZE="$font_size" FACE="$font_face_2" COLOR="$font_color_2">
      	<b>$text_omm "$r_in->{'subject'}"</b><BR></FONT>
    		<FONT SIZE="-1" FACE="$font_face_2" COLOR="$font_color_2">
         Geschrieben von <b>$r_in->{'name'}</b> am
         $this_date um $this_time ($time_zone)<BR></FONT></td></tr>
      <TR BGCOLOR="$bg_color_1"><td colspan="2">
      	<FONT SIZE="$font_size" FACE="$font_face_1" COLOR="$font_color_1">
      	<blockquote>
			$r_in->{'body'}
			</blockquote></FONT></TD></TR>
  		<TR BGCOLOR="$bg_color_2"><TD ALIGN="LEFT">
     		<FONT SIZE="1" FACE="$font_face_2" COLOR="$font_color_2">
    ~;

   if ($r_setup->{'board_setup'}->{'use_icons'} eq "on") {

		my $icons = '';

		unless (	$r_in->{'create_arc'} ) {

			$icons .= qq~<IMG SRC="$imgurl/left_e.gif" BORDER="0">~ if (-e "$imgdir/left_e.gif");
			
	      if ($omm) {
	         $icons .= qq~<a 
				href="$adminurl?az=remove_messages&forum=$forum&thread_select=$r_in->{'om'}&selected=$omm"><IMG 
				SRC="$imgurl/remove.gif" BORDER="0" alt="Beitrag loeschen: Nur fuer den Admin/Moderator"></a>~;
	         $icon_text = " REMOVE ";
	      }
	
	      $icon_text .= " ALERT ";
   	   $icons .= qq~<a 
			href="$exurl?az=alert&forum=$forum&om=$r_in->{'om'}&omm=$omm"><IMG 
			SRC="$imgurl/alert.gif" BORDER="0" alt="Klicken Sie hier um dem Admin/Moderator eine Warnmail zu diesem Beitrag zu senden"></a>~;
		
			$icons .= qq~<IMG SRC="$imgurl/right_e.gif" BORDER="0">~ if (-e "$imgdir/right_e.gif");

		}	
		else {

   	   $icons .= "&nbsp\n";
		}
		
		$html_main_body .= "$icons";

		$icon_text =~ s/^\s+/[/g;
		$icon_text =~ s/\s+$/]/g;
		$icon_text =~ s/\s+/ | /g;

      if ($r_setup->{'board_setup'}->{'icon_text'} eq "on") {
         $html_main_body .= qq~
         <br>
     		<FONT SIZE="1" FACE="$font_face_3" COLOR="$font_color_3">
         $icon_text
			</FONT>
         ~;
      }

      $html_main_body .= qq~
		</FONT>
  		</TD><TD ALIGN="RIGHT">
     		<FONT SIZE="1" FACE="$font_face_3" COLOR="$font_color_3">
      ~;

      $icon_text = "";

		$icons = '';

		if (-e "$imgdir/left_e.gif") {
			$icons .= qq~<IMG SRC="$imgurl/left_e.gif" BORDER="0">~;
		}

      if ($r_setup->{'board_setup'}->{'edit_allowed'} eq "on" && $r_in->{'create_arc'} eq "") {
         $icons .= qq~<a href="$dcpost?az=edit&forum=$forum&om=$r_in->{'om'}&omm=$omm"><IMG 
				SRC="$imgurl/edit.gif" BORDER="0" alt="Diese Nachricht bearbeiten"></a>~;
         $icon_text .= " EDIT ";
      }

      if ($r_in->{'email'}) {
         $icons .= qq~<a href="mailto:$r_in->{'email'}"><IMG SRC="$imgurl/email.gif" 
				 border="0" alt=\"$name eine Email senden\"></a>~;
         $icon_text .= " EMAIL ";
      }

      if ($profile_icon) {
         $icons .= qq~$profile_icon~;
         $icon_text .= " USER ";
      }

		unless (	$r_in->{'create_arc'} ) {
	      $icon_text .= " REPLY \"REPLY\" ";

      	$icons .= qq~<a href="$dcpost?az=post&forum=$forum&om=$r_in->{'om'}&omm=$omm"><IMG 
				SRC="$imgurl/reply.gif" BORDER="0" alt=\"Antwort schreiben\"></a><a 
				href="$dcpost?quote=not_empty&az=post&forum=$forum&om=$r_in->{'om'}&omm=$omm"><IMG 
				SRC="$imgurl/reply_quote.gif" BORDER="0" alt="Auf diesen Beitrag antworten(Quoten)"></a>~;
		}

			$icon_text .= " TOP ";
 
      $icons .= qq~<a href="\#TOP"><IMG 
		SRC="$imgurl/top.gif" border="0" alt="Zur ersten Nachricht dieses Threads"></a>~;

		if (-e "$imgdir/right_e.gif") {
			$icons .= qq~<IMG SRC="$imgurl/right_e.gif" BORDER="0">~;
		}
		
		$html_main_body .= "$icons\n";
		
		$icon_text =~ s/^\s+/[/g;
		$icon_text =~ s/\s+$/]/g;
		$icon_text =~ s/\s+/ | /g;
		
      if ($r_setup->{'board_setup'}->{'icon_text'} eq "on") {
         $html_main_body .= qq~
         <br>
         $icon_text
         ~;
      }

      $html_main_body .= qq~
         </FONT></TD></TR></TABLE>
      ~;
   }
   else {

      $html_main_body .= qq~
  		&nbsp;</FONT></TD><TD ALIGN="RIGHT">
     		<FONT SIZE="1" FACE="$font_face_3" COLOR="$font_color_3">
			~;

      if ($omm) {
         $html_main_body .= qq~
         [<a href="$adminurl?az=remove_messages&forum=$forum&thread_select=$r_in->{'om'}&selected=$omm">REMOVE</a>]
         ~;
      }

		unless (	$r_in->{'create_arc'} ) {
	      $html_main_body .= qq~
         [<a href="$exurl?az=alert&forum=$forum&om=$r_in->{'om'}&omm=$omm">ALERT</a>]
   	   ~;
		}
#$r_setup->{'forum_type'}->{$forum} ne 'Public' && 
      if ($r_setup->{'board_setup'}->{'edit_allowed'} eq "on" && $r_in->{'create_arc'} eq "") {
         $html_main_body .= qq~
         [<a href="$dcpost?az=edit&forum=$forum&om=$r_in->{'om'}&omm=$omm">EDIT</a>]
         ~;
      }

      if ($r_in->{'email'}) {
         $html_main_body .= qq~
            [<a href="mailto:$r_in->{'email'}">Email schicken</a>]
				~;
      }

      if ($profile_name) {
         $html_main_body .= qq~
            [$profile_name]
				~;
      }

		unless (	$r_in->{'create_arc'} ) {
	      $html_main_body .= qq~
         <br>
         [<a href="$dcpost?az=post&forum=$forum&om=$r_in->{'om'}&omm=$omm">REPLY</a>]
         [<a href="$dcpost?quote=not_empty&az=post&forum=$forum&om=$r_in->{'om'}&omm=$omm">REPLY WITH QUOTE</a>]
         ~;
		}

	      $html_main_body .= qq~
			[<a href="\#TOP">TOP</a>] 
        </FONT></TD></TR></TABLE>
      ~;
   }

}


####
# function get_record
# Retrieves one record from the main listing database
#
####

sub get_record {

	my ($r_rowdata,$omm) = @_;
	my ($level,$subject,$name,$email,$ltime,$date,$body);

        $r_rowdata = readdata("$maindir/$forum/$thread_dir/$r_in->{'om'}.$thread_ext");
	# First get the number of messages and the next message number

	my $temp = shift @{$r_rowdata};
   foreach (@{$r_rowdata}) {
      chomp;
# BIG5
#		my @temp = split /::/;
		my @temp = split /\|/;
      if ($omm eq $temp[0]) {
			($omm,$level,$subject,$name,$email,$ltime,$date,$body) = @temp;
# BIG5
#			$body =~ s/&pip;/::/g;
#			$subject =~ s/&pip;/::/g;

			$body =~ s/&pip;/\|/g;
			$subject =~ s/&pip;/\|/g;
			last;
	   }
   }
	return ($omm,$level,$subject,$name,$email,$ltime,$date,$body);
}



####
#
# subroutine clean_old_rand_files
#
# remove old rand files, which are used to
# prevent double postings.
#
####

sub clean_old_rand_files {

   my $dir = shift;
   my $delta = 1;
   opendir(D,"$dir") || die $!;
   while ($file = readdir(D)) {
      if ($file =~ /[0-9]+.dat/ && -M $file >= $delta) {
         unlink("$dir/$file");
      }
   }
   closedir(D);
}

####
#
# subroutine display_status
# display various status
#
#####

sub display_status {

  my ($type,$r_in,$r_setup) = @_;

  print "\n";

  $r_in->{'orig_body'} =~ s/"/&quot;/g;

  if ($type eq "pview") {

    $html_output .= html_main_body($r_in,$r_setup);

    $heading = "Vorschau auf Ihren Beitrag";
    $sub_heading = "Um Ihre Nachricht zu &auml;ndern,<BR>klicken Sie auf den Back Button Ihres Browsers.";

		$html_output .= qq~
      <FORM METHOD="POST">
      <input type=hidden name="forum" value="$forum">
      <input type=hidden name="om" value="$r_in->{'om'}">
      <input type=hidden name="rand1" value="$r_in->{'rand1'}">
      <input type=hidden name="omm" value="$r_in->{'omm'}">
      ~;

		
      if ($r_in->{'type'} eq 'e_mesg') {
         $html_output .= qq~
         <input type=hidden name="az" value="e_mesg">
         ~;
      }
      else {
         $html_output .= qq~
         <input type=hidden name="az" value="a_mesg">
         ~;
      }

      $html_output .= qq~
      <input type=hidden name="email_notification" value="$r_in->{'email_notification'}">
      <input type=hidden name="name" value="$r_in->{'name'}">
      <input type=hidden name="email" value="$r_in->{'email'}">
      <input type=hidden name="subject" value="$r_in->{'subject'}">
      <input type=hidden name="preview_body" value="$r_in->{'orig_body'}">
		<CENTER>
     <font SIZE="$font_size_3" FACE="$font_face_3" color="$font_color_3">
      <B>Wollen Sie Ihren Beitrag eintragen?</B><P>
		</font>
      <input type=submit value="OK - Beitrag absenden">
     </CENTER>
     ~;
   }
   elsif ($type eq "EMail") {   
      $heading = "FEHLER: Falsche EMail";
         $r_in->{'body'} =~ s/<p>/\n\n/gi;
         $r_in->{'body'} =~ s/<br>/\n/gi;
      $sub_heading = "Tragen Sie Ihre richtige Email Adresse ein um per Mail ueber Antworten informiert zu werden.";
      $html_output .= post($r_in,$r_setup);
   }
   elsif ($type eq "No Keywords") {
      $heading = "FEHLER: Kein Suchbegriff";
      $sub_heading = "<b>Sie haben keinen Suchbegriff eingetragen.
              Bitte starten Sie Ihre Suche neu</b>";
      $menu_button = create_button("search",$r_in,$r_setup);
      $html_output .= "<center>\n";
      $html_output .= create_search_form($r_in,$r_setup);
      $html_output .= "</center>\n";
   }
   elsif ($type eq "Kein Treffer") {
      $heading = "Suchergebnis: Keine passenden Beitraege gefunden";
      $sub_heading = "<font size=\"3\"><b>Zu dem Suchbegriff \"$r_in->{'keywords'}\" wurde kein Beitrag gefunden.<BR>Bitte starten Sie Ihre Suche erneut.</b></font><p>";
      $menu_button = create_button("search",$r_in,$r_setup);
      $html_output .= "<center>\n";
      $html_output .= create_search_form($r_in,$r_setup);
      $html_output .= "</center>\n";
   }
   elsif ($type) {   
      $heading = "FEHLER: $type wurde nicht ausge&uuml;llt.";
      $sub_heading = "Sie haben nicht alle Felder ausgef&uuml;llt!";
      $menu_button = create_button("search",$r_in,$r_setup); 
      $r_in->{'body'} =~ s/<p>/\n\n/gi;
      $r_in->{'body'} =~ s/<br>/\n/gi;
      $html_output .= "<center>\n";
      $html_output .= post($r_in,$r_setup);
	  $html_output .= "</center>\n";
   }

   else {
      $heading = "Fehlermeldung";
   }

   my %namespace =  (
     FORUMLINKS => $html_forum_links,
     MENU => $menu_button,
     TITLE => $heading,
     HEADER => $heading,
     SUBHEADER => $sub_heading,
     HTMLOUTPUT => $html_output
   );

  &display_output($templatefile,\%namespace);

  exit(0);

}


####
# function remove_badwords
#
# Removes badwords
####

sub remove_badwords {

    my ($r_in,$r_setup) = @_;

    my @words = split(/\,/, $r_setup->{'board_setup'}->{'bad_word_list'});

    foreach (@words) {

        $r_in->{'subject'} =~ s/\b$_\b/#####/ig;
        $r_in->{'body'} =~ s/\b$_\b/#####/ig;

    }

    return 0;

}


####
#
# subroutine show_thread
# reads in a Private Thread Display it.
#
####

sub show_thread {

   my ($r_in,$r_setup) = @_;
	my $html_main_body;
	my $html_orig_body;
   my $r_user_mark = get_user_mark($r_in,$r_setup);
   my $r_thread  = readdata("$maindir/$forum/$r_in->{'om'}.$ext");

   $| = 1;

	print "\n";


	if ($r_in->{'omm'} eq '') {
		print "@{$r_thread}\n";
	   exit;
	}
	else {

		my $r_thread = readdata("$maindir/$forum/$thread_dir/$r_in->{'om'}.$thread_ext");

		shift(@$r_thread);
		my $prev_level = 0;

		foreach (@$r_thread) {

			chomp;
# BIG5
#			my ($omm,$level,$subject,$name,$email,$ltime,$date,$body) = split /::/;
			my ($omm,$level,$subject,$name,$email,$ltime,$date,$body) = split /\|/;
			$name .= $team_name if ($team =~ /\b$name\b/);

			if ($omm == $r_in->{'omm'}) {
				$r_in->{'subject'} = $subject;
	      	$r_in->{'name'} = $name;
	      	$r_in->{'email'} = $email;
	      	$r_in->{'ltime'} = $ltime;
	      	$r_in->{'date'} = $date;
	      	$r_in->{'body'} = $body;

# BIG5
#				$r_in->{'body'} =~ s/&pip;/::/g;
#				$r_in->{'subject'} =~ s/&pip;/::/g;
				$r_in->{'body'} =~ s/&pip;/\|/g;
				$r_in->{'subject'} =~ s/&pip;/\|/g;
				$html_main_body = html_main_body($r_in,$r_setup);

			}

	  		my $icon = "file.gif";
	  		my $new_icon = "";
			my $space = ($level-2)*$level_spacing + 1;

		   if ($r_user_mark->{$forum} ne "") {
      		   my ($hh,$minute,$second) = split(/\:/, $ltime);
         		my ($mmonth,$dd,$yy) = split(/\//, $date);
					$yy += 1900 if ($yy < 101);
         		my $last_mesg = compute_time($yy, $mmonth, $dd, $hh, $minute, $second);
         		$new_icon = "<img src=\"$imgurl/newmark.gif\">, " if ($last_mesg > $r_user_mark->{$forum});
     		}

			$ltime = time_format($ltime);
	 		$date = date_format($date);

			$icon = 'folder.gif' if ($level == 1);
			$space = 1 if ($level == 1);

			unless ($omm == $r_in->{'omm'}) {
				if ($r_setup->{'board_setup'}->{'use_icons_toc'} eq 'on') {
					$toc .= qq~
					<img src=\"$imgurl/blank.gif\" width=\"$space\" height=\"14\"><img 
					src=\"$imgurl/$icon\"> <a href="$exurl?az=show_thread&omm=$omm&om=$r_in->{'om'}&forum=$forum">$subject</a>, $new_icon
					<b>$name</b>, <font size="1">$date, ($omm)</font><br>~;
				}
				else {

					if ($level > $prev_level) {
						for ($j=0;$j<$level-$prev_level;$j++) {
							$toc .= "<ul>\n";
							$ul_count++;
						}
					}
					elsif ($level < $prev_level) {
						for ($j=0;$j<$prev_level-$level;$j++) {
							$toc .= "</ul>\n";
							$ul_count--;
						}
					}

					$prev_level = $level;
        	     	$toc .= qq~
              	    <li><a href="$exurl?az=show_thread&omm=$omm&om=$r_in->{'om'}&forum=$forum">$subject</a>, $new_icon
              	    <b>$name</b>, <font size="1">$ltime, $date</font>
              	    ~;
				}
			}
			else {

				if ($r_setup->{'board_setup'}->{'use_icons_toc'} eq 'on') {
					$toc .= qq~
					<img src=\"$imgurl/blank.gif\" width=\"$space\" height=\"14\"><img 
					src=\"$imgurl/$icon\"> <b>$subject, $new_icon
					$name</b>, <font size="1">$date, ($omm)</font><br>~;
				}
				else {

				if ($level > $prev_level) {
					for ($j=0;$j<$level-$prev_level;$j++) {
						$toc .= "<ul>\n";
						$ul_count++;
					}
				}
				elsif ($level < $prev_level) {
					for ($j=0;$j<$prev_level-$level;$j++) {
						$toc .= "</ul>\n";
						$ul_count--;
					}
				}

					$prev_level = $level;
        	     	$toc .= qq~
              	    <li><b>$subject</b>, <b>$name</b>, <font size="1">$ltime, $date</font>
              	    ~;
				}
			}

			$toc = '' if ($omm == 0);

		}


		for ($j=0;$j<$ul_count;$j++) {
			$toc .= "</ul>\n";
		}

		&toggle_color();

	# Create main-lobby icons
    # they will be placed at the botton of table of contents

	if (-e "$imgdir/left_e.gif") {
		$main_lobby .= qq~<IMG 
		SRC="$imgurl/left_e.gif" BORDER="0">~;
	}

	$main_lobby .= qq~<a 
		href="$boardurl?az=list&forum=$forum"><IMG 
			SRC="$imgurl/home.gif" BORDER="0" 
			alt="Zur Themen&uuml;bersicht"></a><a 
			href="$boardurl"><IMG SRC="$imgurl/mainforum.gif" BORDER="0" 
			alt="Zur&uuml;ck zur Foren&uuml;bersicht Lobby"></a>~;

	if (-e "$imgdir/right_e.gif") {
		$main_lobby .= qq~<IMG 
		SRC="$imgurl/right_e.gif" BORDER="0">~;
	}

	      $html_output .=qq~
			<TABLE BORDER="0" WIDTH="$table_width" cellspacing="0" cellpadding="3">
			<TR BGCOLOR="$bg_color_0">
			<TH ALIGN="LEFT">
			<font SIZE="3" FACE="$font_face_0" color="$font_color_0">
			Aktueller Beitrag
			</font></TH>
			</TR></TABLE>
			$html_main_body
			<br>
			<TABLE BORDER="0" WIDTH="$table_width" cellspacing="0" cellpadding="3">
			<TR BGCOLOR="$bg_color_0">
			<TH ALIGN="LEFT">
			<font SIZE="3" FACE="$font_face_0" color="$font_color_0">
			Uebersicht der Beitraege
			</font></TH>
			</TR></TABLE>
				<TABLE BORDER="0" WIDTH="$table_width" cellspacing="1" cellpadding="3">
   	      <TR BGCOLOR="$bgcolor"><TD ALIGN="LEFT" VALIGN="TOP">
				<FONT SIZE="$font_size" COLOR="$font_color" FACE="$font_face">
				$toc
				</FONT>
	            </TD>
	      </TR><TR BGCOLOR="$bgcolor"><TD ALIGN="Right" VALIGN="TOP">
				<FONT SIZE="$font_size" COLOR="$font_color" FACE="$font_face">
				$main_lobby
				</FONT>
	            </TD>
	      </TR>
			</table>
	      ~;
	}

}



###
#
# subroutine format_quote
#
# Takes original message and formats it
# with ">" sign
###

sub format_quote {

   my $quote = shift;

   my @reply_paragraphs = split(/\<P\>/,$quote);

   $quote = "";
  
   foreach $para (@reply_paragraphs) {

	  	$para =~ s/<br>/\n/gi;
	   $para =~ s/<([^>]|\n)*>//g;
		if ($para =~ />/) {
			my @lines = split(/\n/,$para);
			foreach (@lines) {
		      $quote .= ">$_\n";
			}
		}
		else {
	      $para =~ s/<([^>]|\n)*>//g;
   	   my @reply_body = split(/\s/,$para);
      	my $j = 0;
         $quote .= ">";
  	     foreach (@reply_body) {
           $quote .= "$_ ";
           if ($j == 6) {
              $quote .= "\n>";
              $j = 0;
           }
           $j++;
        }
	  }

     $quote .= "\n";
  }

  return $quote;

}



#-------------------------------------------
# subroutine get_form_variables
#-------------------------------------------

sub get_form_variables {

   my ($r_in,$r_setup) = @_;

   remove_badwords($r_in,$r_setup);

   unless ($r_in->{'name'}) {
      display_status(Name,$r_in,$r_setup);
   }

   if ($r_in->{'subject'}) {
		$r_in->{'subject'} =~ s/&gt;/>/g;
		$r_in->{'subject'} =~ s/&lt;/</g;

# BIG5
#		$r_in->{'subject'} =~ s/::/&pip;/g;

		$r_in->{'subject'} =~ s/\|/&pip;/g;
      $r_in->{'subject'} =~ s/<([^>]|\n)*>//g;
      $r_in->{'subject'} =~ s/\&/\&amp\;/g;
      $r_in->{'subject'} =~ s/"/\&quot\;/g;
   }
   else {
      display_status(Subject,$r_in,$r_setup);
   }

	if ($r_in->{"email_notification"}) {
		unless ( &check_email($r_in->{'email'}) ) {	
	      &display_status(EMail,$r_in,$r_setup);
		}
	}	

	if ($r_in->{'body'}) {

# BIG5
#		$r_in->{'body'} =~ s/::/&pip;/g;
		$r_in->{'body'} =~ s/\|/&pip;/g;

		unless ($r_setup->{'board_setup'}->{'html_allowed'} eq "on") {
			$r_in->{'body'} =~ s/<([^>]|\n)*>//g;
      }
		else {
			$r_in->{'body'} =~ s{<a href="(.*)">(.*)</a>}{$1}gio;
		}
		
		my $urls = '(' . join ('|', qw{
												http
												ftp 
												mailto
												}
										)
								. ')';

		my $ltrs = '\w';
		my $gunk = '/#~:.?+=&%@!\-';
		my $punc = '/.:?\-';
		my $any = "${ltrs}${gunk}${punc}";
		
		$r_in->{'body'} =~ s{\b(${urls}:[$any]+?)(?=[$punc]*[^$any]|\Z)}
			{<a href="$1">$1</a>}goi;
		
    	if ($r_setup->{'board_setup'}->{'image_allowed'} eq "on") {
      	$r_in->{'body'} =~ s/image:(\S+)$b/<img src="http:\/\/$1">/gi;
      }

		$r_in->{'body'} =~ s/:-\(\(/<img src="$imgurl\/angry.gif">/g;
		$r_in->{'body'} =~ s/:-\)/<img src="$imgurl\/happy.gif">/g;
		$r_in->{'body'} =~ s/:-\(/<img src="$imgurl\/sad.gif">/g;
		$r_in->{'body'} =~ s/;-\)/<img src="$imgurl\/wink.gif">/g;

		$r_in->{'body'} =~ s/\cM//g;

		$r_in->{'orig_body'} = $r_in->{'body'};
		$r_in->{'orig_body'} =~ s/>/ampgt;/g;
		$r_in->{'orig_body'} =~ s/</amplt;/g;
		$r_in->{'body'} =~ s/\\gt;/&gt;/g;
		$r_in->{'body'} =~ s/\\lt;/&lt;/g;
      $r_in->{'body'} =~ s/\n\n/<P>/g;
      $r_in->{'body'} =~ s/\n/<BR>/g;
      $r_in->{'body'} =~ s/&quot;/"/g;	   

   }
	elsif ($r_in->{'preview_body'}) {
  
    	$r_in->{'body'} = $r_in->{'preview_body'};
    	$r_in->{'body'} =~ s/ampgt;/>/g;
    	$r_in->{'body'} =~ s/amplt;/</g;
		$r_in->{'body'} =~ s/\\gt;/&gt;/g;
		$r_in->{'body'} =~ s/\\lt;/&lt;/g;
    	$r_in->{'body'} =~ s/\cM//g;
    	$r_in->{'body'} =~ s/\n\n/<P>/g;
		$r_in->{'body'} =~ s/\n/<BR>/g;
		$r_in->{'body'} =~ s/&quot;/"/g;

	}
   else {
      display_status(Message,$r_in,$r_setup);
   }

}



1;

