# dcprotect.pl - an authentication script
# Written By David S. Choi, dc@sitedeveloper.com
# 15 June 1998
# 
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCForum.
# You should carefully read this terms agreement as outlined in
# the readme.txt file included with this distribution before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
###################################################################
##  German translation by Lothar Jung for Webster Internet Dienstleistungen
##  http://Webster.de/dcscripts/
###################################################################

sub dcprotect {

   my ($thisurl,$datadir,$r_in,$r_login_fields,$r_form_type) = @_;
   my ($heading,$sub_heading,$html_output);

   # Initialize script hash $r_in and $r_local
   # This subroutine acts as an interface to the mother script
	$r_in->{'datadir'} = $datadir;

   my $r_local = init($thisurl,$datadir,$r_in,$r_login_fields,$r_form_type);
	$r_setup = initialize($password_file_dir,$forum_file,$board_setup_file);

	require "$cgidir/global.pl";
	
   if ($r_in->{'dc_action'} eq 'login' && $r_in->{'login'} ne "") {

      $error = check_password($r_in,$r_local);

      unless ($error) {

			my $session = get_session_id();

			# If Rembering of password is allowed, then
			# add '%%' to the session id so that
			# remove_session_files won't remove them
			
			if ($r_in->{'remember'}) {
				$session = '%%' . $session;
	      	send_cookie($r_local->{'cookie_name'},$session,
						$r_in->{'expires'},$r_local->{'domain'});
			}
			else {
	      	send_cookie($r_local->{'cookie_name'},$session,
  	      	$r_local->{'expires'},$r_local->{'domain'});
			}

			my @temp_array;

     		foreach (keys %{ $r_local->{'login_fields'} }) {
				unless ($_ eq "Password") {
					my $temp_string = join ("::",$_,$r_local->{'login_info'}->{$_});
        			push(@temp_array,"$temp_string\n");
				}
      	}

			my $access = "Forums::";
   		foreach $forum (@{$r_setup->{'forums'}}) {
				if ($r_setup->{'forum_type'}->{$forum} eq 'Private') {
					if (-e "$password_file_dir/$forum.$priv_user_ext") {
						$r_members = readdata("$password_file_dir/$forum.$priv_user_ext");
					}
					foreach (@{$r_members}) {
						chomp;
						if ($r_local->{'login_info'}->{'Username'} eq $_) {
							$access .= "$forum,";
							$r_local->{'login_info'}->{'Forums'} .= "$forum,";
							last;
						}
					}
				}
			} # End of $forum..etc

			chop($access) if ($access =~ /\,$/);
        	push(@temp_array,"$access\n");
			
			# Create session file
			writedata_nolock("$datadir/$session.session",\@temp_array);
			return $r_local->{'login_info'};

      }    
      else {
	 
         print "\n";
         $heading = "DCForum Login";
         $sub_heading = "<b><font size=3>Login Fehler: $error<br></font></b>\n";
         $html_output .= display_logon($r_in,$r_local);

      } #End of Unless

   }# End of if ($r_in->{'dc_action'} eq 'login' &&
   # Check and see if one of the management function was chosen
   elsif ($r_in->{'dc_action'} eq 'usermanage' ||
          $r_in->{'dc_action'} eq 'configure') {

      print "\n";	#End of HTTP Header

      my $session = get_cookie($r_local->{'cookie_name'});

      if ($session) {

			$r_in->{'session'} = $session;
      	$r_local->{'login_info'} = get_userdata("$datadir/$session\.session");

      	if ($r_in->{'dc_action'} eq 'usermanage') {
        		check_group($r_in,$r_local,"admin");
        		$heading = $main_heading;
        		($sub_heading, $html_output) = user_manager($r_in,$r_local);

      	}
      	elsif ($r_in->{'dc_action'} eq 'configure') {
        		check_group($r_in,$r_local,"admin");
        		$heading = $main_heading;
        		$sub_heading = "";
        		$html_output = configure($r_in,$r_local);
      	}
		}  
    	else {
      	$heading = "DCForum Login";
      	$sub_heading = "Bitte tragen Sie Ihre Accountdaten ein.";
      	$html_output = display_logon($r_in,$r_local);
     }

  }

  # The user has clicked on Register button

  elsif ($r_in->{'dc_action'} eq 'login' && $r_in->{'Register'} ne "") {
    print "\n";

    $heading = "DCForum Registrierung";
    $sub_heading = "Bitte f&uuml;llen Sie das Formular vollst&auml;ndig aus. 
      (*) indicates required field";
    $html_output = output_form($r_in,$r_local);

  }

  # The user completed registration form

  	elsif ($r_in->{'dc_action'} eq 'register') {

		# End of HTTP Header
    	print "\n";
    	$heading = "DCForum Registrierung";
    	my @required = split(/\,/,$r_in->{'required'}); 

		if ($r_local->{'auth'}->{'Register Via EMail'} eq "on") {
			my $session = get_session_id();
	  		$r_in->{'Password'} = substr($session,3,6);
	  		$r_in->{'dup_Password'} = substr($session,3,6);
  		}

    	foreach (@required) {
      	unless ($r_in->{$_}) {
        		push(@ERROR,$_);
      	}
    	}
    
  		# Check and see if all required fields are completed
  
    	if (@ERROR) {
      	$sub_heading = "Registrierung nicht vollst&auml;ndig";
      	$html_output .= qq~
      	<h4 align="center">
      	Sie haben nicht alle erforderlichen Felder ausgefuellt.<br>
      	Bitte korigieren Sie Ihre Eingaben.
      	</h4>~;
			
      	$html_output .= output_form($r_in,$r_local);
    	}
    	else {

			$username = $r_in->{'Username'};
			$password = $r_in->{'Password'};
	      $error = register($r_in,$r_local);

	      if ($error) {
        $sub_heading = "$error";
        $html_output = output_form($r_in,$r_local);
      }
      else {        
 
        if ($r_local->{'auth'}->{'Notify Admin on Register'} eq "on") {

          my $subject = "Neue User Registrierung";
          my $mail_message = "Auf Ihrer Seite hat sich ein neuer User registriert.\n";
          $mail_message .= "Nachfolgend alle eingetragenen Daten.\n";
          foreach (@{$r_login_fields}) {
            $mail_message .= "$_: $r_in->{$_}\n";
          }
          send_mail($datadir, $r_local->{'auth'}->{'Sendmail Path'},
            $r_local->{'auth'}->{'Admin EMail Address'},
            $r_local->{'auth'}->{'Admin EMail Address'},
            $subject,$mail_message );
        }

  			if ($r_local->{'auth'}->{'Register Via EMail'} eq "on") {
				
          my $subject = "DCForum - Ihre Registrierung auf $homeurl";
          my $str = "Ihr Username ist: $username\n";
          $str .= "Ihr Passwort ist: $password";
			 my $mail_message = $registration_email_message;
			 $mail_message =~ s/USERNAME_PASSWORD/$str/;

          send_mail($datadir, $r_local->{'auth'}->{'Sendmail Path'},
            $r_local->{'auth'}->{'Admin EMail Address'},
            $r_in->{'EMail'},$subject,$mail_message );

	        $sub_heading .= qq~
						Das Passwort wurde Ihnen per Mail zugestellt.<br>&nbsp;<br>
						Wenn Sie nicht innerhalb der naechsten 24 Stunden eine Mail<br>
						erhalten, schreiben Sie bitte dem Administrator der Seite.
						<br>Vielen Dank.<p>~;
						
		      $html_output .= display_logon($r_in,$r_local);

				}
        elsif ($r_local->{'auth'}->{'Activate User on Register'} eq 'on') {
          $sub_heading = "Ihre Daten wurden in die Datenbank uebernommen.<br>&nbsp;<br>
						Sie koennen sich jetzt mit Ihrem Usernamen und Passwort anmelden.";
		      $html_output = display_logon($r_in,$r_local);
        }
        else {
          $sub_heading .= qq~
          <p>
          Ihre Daten wurden in die Datenbank uebernommen.
          <br>Ihr Account wurde aber noch nicht aktiviert.
          <br>Sie erhalten eine Mail, sobald Ihr Account
          <br>freigeschaltet wurde.<BR>Vielen Dank.
          <p>
          ~;
        }

         }
      } 
   }

   else {

      my $session = get_cookie($r_local->{'cookie_name'});
		
      if ($session && -e "$datadir/$session.session") {
         $r_local->{'login_info'} = get_userdata("$datadir/$session.session");
         return ($r_local->{'login_info'});
      }
      else {

			unless ($r_in->{'az'} ne "login") {
				unlink "$datadir/$session\.session" if (-e "$datadir/$session\.session");
				my $expires = "Sat, 04-Jul-98 12:00:00 GMT";
	         send_cookie($r_local->{'cookie_name'},$cookie,$expires,$r_local->{'domain'});
			}
			print "\n";
		
			# Following modification is needed to distinguish board from admin
      	$heading = "DCForum Login";
      	$sub_heading = "Bitte tragen Sie Ihren Usernamen und das Passwort ein.";     
      	$html_output = display_logon($r_in,$r_local);
    	}
  	}

  my $menu_button = menu($r_in);
  my %namespace = (
    HEADER => $heading,
    MENU => $menu_button,
    SUBHEADER => $sub_heading,
    HTMLOUTPUT => $html_output );

  display_output($templatefile,\%namespace); 

  exit(0);

}


####
#
# subroutine init
#
###

sub init {

  my ($thisurl,$datadir,$r_in,$r_login_fields,$r_form_type) = @_;

  my $r_local = {};

# Let's clean up form data
# remove control characters and etc...

  $r_local->{'thisurl'} = $thisurl;
  $r_local->{'fields'} = $r_login_fields;

  $r_local->{'setup_file'} = "$datadir/$r_in->{'auth_setup_file'}";
  $r_local->{'password_file'} = "$datadir/$r_in->{'password_file'}";
  
  #Let's include Username,Password, and Group

  unshift(@$r_login_fields,"Password","Username","Group");
  push(@$r_login_fields,"Status");

# BIG5
#  my @variables = (
#    'Admin EMail Address::you@youremail.com',
#    'Sendmail Path::/usr/lib/sendmail',
#    'Register Via EMail::off',
#    'Allow Users to Register::on',
#    'Default Group::normal',
#    'Activate User on Register::on',
#    'Allow Remembering of Password::on',
#    'Notify Admin on Register::off',
#    'Notify User on Act/Deactivation::off',
#    'Bad EMail List::hotmail.com,usa.net,iname.com,excitemail.com',
#    'Allow Users to Modify Account Infomation::on',
#    'Allow Users to Change Password::on'
#  );


  my @variables = (
    'Admin EMail Address|you@youremail.com',
    'Sendmail Path|/usr/lib/sendmail',
    'Register Via EMail|off',
    'Allow Users to Register|on',
    'Default Group|normal',
    'Activate User on Register|on',
    'Allow Remembering of Password|on',
    'Notify Admin on Register|off',
    'Notify User on Act/Deactivation|off',
    'Bad EMail List|hotmail.com,usa.net,iname.com,excitemail.com',
    'Allow Users to Modify Account Infomation|on',
    'Allow Users to Change Password|on'
  );

  check_datafile($r_local->{'setup_file'},\@variables);

  # Check and make sure profile directory is there
  check_dir("$datadir/$profile_dir");

  # read in setup parameters to $r_local->{'auth'}

  $r_local->{'auth'} = {};

  get_setup_variables($r_local->{'setup_file'},$r_local->{'auth'});

  # Let's define form type
  # NOTE: Status is 'hidden' if this is a new user registration

# BIG5
#  $r_form_type->{'Username'} = 'text::40::required';
#  $r_form_type->{'Password'} = 'password::40::required';
#  $r_form_type->{'Group'} = "hidden::$r_local->{'auth'}->{'Default Group'}::required";
#  $r_form_type->{'Status'} = 'radio::on::off';
  
  $r_form_type->{'Username'} = 'text|40|required';
  $r_form_type->{'Password'} = 'password|40|required';
  $r_form_type->{'Group'} = "hidden|$r_local->{'auth'}->{'Default Group'}|required";
  $r_form_type->{'Status'} = 'radio|on|off';

  # Wenn die Passwortdatei ($password_file) leer ist wird der
  # erste der sich registriert als Admin angelegt.

  check_datafile("$password_file_dir/$team_file_name");
  check_datafile($r_local->{'password_file'});

  $r_local->{'form_type'} = $r_form_type;
  
  # Mark off login field locations
  # Needed in subroutines everywhere...
  # $r_in->{$login_field} is a reference to a hash whose
  # keys are the fields and values are the array location
  # $r_local->{'login_info'} is a reference to a hash whose
  # keys are the fields and values are the data read in from
  # the User database
  # $r_in->{'login_data'} is a reference to a hash whose
  # keys are the fields and values are input form values
    
  foreach (@$r_login_fields) {
    $r_local->{'login_fields'}->{$_} = $j;
    $r_local->{'login_info'}->{$_} = '';
    $j++;
  }

  $r_local->{'user_list'} = [];

  # Define Cookie Name

  $r_local->{'cookie_name'} = $r_in->{'cookie_name'};

  # Cookie will expire when the session is over
  
  $r_local->{'expires'} = "";
  $r_local->{'domain'} = "";

  return $r_local;
}


###
# subroutine configure
# function to handle managing the forum
# security manager
###

sub configure {

   my ($r_in,$r_local) = @_;

   # if command is change_settings, the new parameters
   # are saved to the auth variable file

   if ($r_in->{'command'} eq "change_settings") {
      my @rowdata;
    
      $html_output .= qq~
	      <table border="0" width="100%" cellpadding="2">
	      <TR BGCOLOR="$bg_color_3"><TH ALIGN="CENTER" VALIGN="CENTER" COLSPAN="2">
			<font size="3" color="$font_color_3" face="$font_face_3">
	      Die Sicherheitsdatei fuer Ihr Forum wurde geaendert.
			<br><font size="2">
			Nachfolgend die neuen Einstellungen.</font></font></TH></TR>~;

      foreach (keys %{$r_local->{'auth'}}) {
# BIG5
#      	$temp = join("::",$_,$r_in->{$_});      
      	$temp = join("\|",$_,$r_in->{$_});      
      	push(@rowdata,"$temp\n");
      	$html_output .=qq~
      		<TR><TH ALIGN="RIGHT" VALIGN="CENTER" BGCOLOR="$bg_color_2">
				<font size="$font_size_2" color="$font_color_2" face="$font_face_2">
        		$_</font></TH>
        		<TD ALIGN="LEFT" VALIGN="CENTER" BGCOLOR="$bg_color_1">
				<font size="$font_size_1" color="$font_color_1" face="$font_face_1">
        		$r_in->{$_}</font></TD></TR>~;
		} # end of foreach
		
		$html_output .= qq~
    		<tr bgcolor="$bg_color_3"><td colspan="2">&nbsp;</td></tr>
      	</table>~;
    
      writedata($r_local->{'setup_file'},\@rowdata);
    
   }
   else {
    
      $html_output .= qq~
      <form action="$r_local->{'thisurl'}" method="post">
      <input type="hidden" name="dc_action" value="configure">
      <input type="hidden" name="command" value="change_settings">

      <table border="0" width="100%" cellpadding="2">
      	<TR BGCOLOR="$bg_color_3">
      	<td colspan="2"><font size="3" color="$font_color_3" face="$font_face_3">
			<b>DCForum Security Manager</b><font size="2">
        	<br>Um die Sicherungseinstellungen fuer DC Forum zu aendern,
			waehlen Sie eine der folgenden Optionen.</font></font></td></tr>
      	<TR BGCOLOR="$bg_color_3">
      	<th align=""left"><font size="$font_size_3" color="$font_color_3" face="$font_face_3">
			<b>Parameter</b></font></th>
			<td aling="left"><font size="$font_size_3" color="$font_color_3" face="$font_face_3">
			<b>Aktuelle Einstellungen</b></font></td></tr>~;

      foreach (keys %{$r_local->{'auth'}}) {
	      $html_output .= qq~
	      <tr><th align="right" bgcolor="$bg_color_2">
			  <font size="$font_size_2" color="$font_color_2" face="$font_face_2">
	        $_</font></th>~;

      	if ($_ eq "Default Group") {
	         my @group = qw(admin normal member team moderator);
	         $html_output .= qq~
	         <td align="left" bgcolor="$bg_color_1">
			   <font size="$font_size_1" color="$font_color_1" face="$font_face_1">
	         <select name="$_">~;
        
        		foreach $group (@group) {
          		if ($r_local->{'auth'}->{$_} eq $group) {
            		$html_output .= "<option value=\"$group\" selected>$group\n";
          		}
          		else {
           	 		$html_output .= "<option value=\"$group\">$group\n";
          		}
        		}
        		$html_output .= qq~
        		</select></font></td>~;
         }
         elsif ($r_local->{'auth'}->{$_} eq "on") {
        		$html_output .= qq~
        		<td align="left" bgcolor="$bg_color_1">
		  		<font size="$font_size_1" color="$font_color_1" face="$font_face_1">
            <input type="radio" name="$_" value="on" checked>On
            <input type="radio" name="$_" value="off">Off</font></td>~;
         }
         elsif ($r_local->{'auth'}->{$_} eq "off") {
            $html_output .= qq~
            <td align="left" bgcolor="$bg_color_1">
		      <font size="$font_size_1" color="$font_color_1" face="$font_face_1">
            <input type="radio" name="$_" value="on">On
            <input type="radio" name="$_" value="off" Checked>Off
            </font></td>~;
         }
         else {
            $html_output .= qq~
            <td align="left" bgcolor="$bg_color_1">
		      <font size="$font_size_1" color="$font_color_1" face="$font_face_1">
            <input type="text" name="$_" value="$r_local->{'auth'}->{$_}" size="40">
            </font></td>~;
         }
         $html_output .= qq~</tr>~;

      } # end of foreach

      $html_output .= qq~
    	<tr bgcolor="$bg_color_3"><td>&nbsp;</td>
      <td align="left" bgcolor="$bg_color_3">
      <input type="submit" value="absenden">
      <input type="reset" value="l&ouml;schen">
      </td></tr></table></form>~;
   }

   return $html_output;
}


######
# subroutine user_manager
# routines to manage user database
# Only admin can use this function :-)
######

sub user_manager {

   my ($r_in,$r_local) = @_;

   if ($r_in->{'command'} eq 'save') {

      print "\n";

      $heading = "DCForum User Registrierung - Ergebnis";
      my @required = split(/\,/,$r_in->{'required'});

      foreach (@required) {
         unless ($r_in->{$_}) {
            push(@ERROR,$_);
         }
      }
    
      # Check and see if all required fields are completed

      if (@ERROR) {
         $sub_heading = "Registrierung nicht vollstaendig";
         $html_output = "Sie haben nicht alle erforderlichen Felder ausgefuellt.";
         $html_output .= output_form($r_in,$r_local);
      }
      else {

         if ($r_in->{'sub_action'} eq 'modify') {

            $error = update_user($r_in,$r_local);

				# Now recreate listing of team members
				$r_in->{'Group_type'} = 'team';
	         get_user_list($r_in,$r_local,'');
				my @this;

		      foreach (@{$r_local->{'user_list'}}) {
		      	my @fields = @{$_};
	            push(@this,"$fields[$r_local->{'login_fields'}->{'Username'}]\n");
    	      }

				writedata("$password_file_dir/$team_file_name",\@this);
            $status = "Der Useraccount wurde geaendert.";

         }
         else {
             $error = register($r_in,$r_local);
             $status = "Der neue Useraccount wurde angelegt.";
         }

         if ($error) {
            $sub_heading = "$error";
            $html_output = output_form($r_in,$r_local);
         }
         else {
             $sub_heading = "$status";
             $html_output = "";
         }
      } 

      return $sub_heading, $html_output;
  
   } # end of if commend eq save

   elsif ($r_in->{'sub_action'} eq 'new_user') {

      $html_output = output_form($r_in,$r_local);
      return $html_output;

   }

   elsif ($r_in->{'command'} eq "list") {
  
      if ($r_in->{'sub_action'} eq 'activate') {
         get_user_list($r_in,$r_local,'off');
         $input_type = "checkbox";
      }
      elsif ($r_in->{'sub_action'} eq 'deactivate') {
         get_user_list($r_in,$r_local,'on');      
         $input_type = "checkbox";
      }
      elsif ($r_in->{'sub_action'} eq 'remove') {
         get_user_list($r_in,$r_local,'');      
         $input_type = "checkbox";
      }
      else {
         get_user_list($r_in,$r_local,'');      
         $input_type = "radio";
      }
    
      $html_output .= qq~
      <form action="$r_local->{'thisurl'}" method="post">
      <input type="hidden" name="dc_action" value="$r_in->{'dc_action'}">
      <input type="hidden" name="sub_action" value="$r_in->{'sub_action'}">
      <input type="hidden" name="command" value="doit">
      <table border="0" width="100%" cellpadding="2">
      <tr bgcolor="$bg_color_3"><td colspan="6">
			<font size="3" color="$font_color_3" face="$font_face_3">
			<b>DCForum User Account Manager</b>:<font size="$font_size_3">
         <br>Waehlen Sie den Account den Sie $r_in->{'sub_action'} moechten.</font>
			</font></td></tr>
      <tr bgcolor="$bg_color_3"><th valign="top">
			<font size="$font_size_3" color="$font_color_3" face="$font_face_3">
		Select</font></th>
      ~;

      # Here, let's only display the first five fields...
	   # Do not display password

      foreach (@{ $r_local->{'fields'} }[1..5]) {
         $html_output .= qq~
           <th valign="top"><font 
			  size="$font_size_3" color="$font_color_3" face="$font_face_3">
           $_&nbsp;</font></th>
         ~;
      }
 
 		$html_output .= "</tr>\n";
      my $users;

		toggle_color('reset');
      foreach (@{$r_local->{'user_list'}}) {
			toggle_color();
      	$users = "yes";
      	my @fields = @{$_};
      	$html_output .= qq~
      		<tr bgcolor="$bgcolor"><td valign="top"><font 
			  size="$font_size" color="$font_color" face="$font_face">
      		<input type="$input_type" name='user_selected'
        			value="$fields[$r_local->{'login_fields'}->{'Username'}]">
      			</font></td>
      	~;
      
	      foreach $field (@{ $r_local->{'fields'} }[1..5]) {
	      $html_output .= qq~
	        <td valign="top"><font 
			  size="$font_size" color="$font_color" face="$font_face">
	        $fields[$r_local->{'login_fields'}->{$field}]
	        &nbsp;</font>
	        </td>
	      ~;
	      }

	      $html_output .= "</tr>\n";
    	}
    
    	unless ($users) {
	      $html_output .= qq~
	      <tr bgcolor="$bgcolor">
	        <th colspan="7" align="center"><font 
			  size="$font_size" color="$font_color" face="$font_face">
	        Es wurde kein passender Usereintrag gefunden!!!
				</font>
	        </th>
	      </tr>
	      ~;
      }

	    $html_output .= qq~
		<tr bgcolor="$bg_color_3">
	      <td colspan="6" align="center">
	      <input type="submit" value="absenden">
	      <input type="reset" value="l&ouml;schen">
	      </td>
	    </tr>
	    </table>
	    </form>~;
    
   } # End of commend eq list - lists users

   elsif ($r_in->{'command'} eq "doit") {

      if ($r_in->{'sub_action'} eq 'modify') {

         get_login_data($r_local->{'password_file'},$r_in->{'user_selected'},$r_local);

      	foreach (keys %{$r_local->{'login_info'}} ) {

				if ($_ eq "EMail") {
					$r_in->{$_} = remove_antispam($r_local->{'login_info'}->{$_});
				}
				else {
        			$r_in->{$_} = $r_local->{'login_info'}->{$_};
				}
				
      	}

      	$html_output = output_form($r_in,$r_local);
      	return $html_output;
		}


      my @user_selected = split(/\0/,$r_in->{'user_selected'});
      $r_in->{'user'} = 'all';
      get_user_list($r_in,$r_local,'');

      my @rowdata;
    
      foreach (@{$r_local->{'user_list'}}) {

      my @fields = @{$_};
      my $hit = "";

      foreach (@user_selected) {

          if ($fields[$r_local->{'login_fields'}->{'Username'}] eq $_) {

          	$hit = "yes";

          	if ($r_in->{'sub_action'} eq 'activate') {

	            $subject = "Ihr Account wurde aktiviert.";
	            $mail_message = "Verifizieren Sie Ihre Anmeldung unter: $r_local->{'thisurl'}";
	            $fields[-1] = 'on';
# BIG5
#	            my $temp = join("::",@fields);
	            my $temp = join("\|",@fields);
	            push(@rowdata,"$temp\n");
	
	          }
	          elsif ($r_in->{'sub_action'} eq 'deactivate') {
	
	            $subject = "Ihr Account wurde aktiviert.";
	            $mail_message = "Weitere Fragen koennen Sie gerne auf diese Mail stellen.";
	            $fields[-1] = 'off';
# BIG5
#	            my $temp = join("::",@fields);
	            my $temp = join("\|",@fields);
	            push(@rowdata,"$temp\n");
	
							if (-e "$r_in->{'datadir'}/$_\.session") {
								unlink("$r_in->{'datadir'}/$_\.session");
							}
	
	          }
	          elsif ($r_in->{'sub_action'} eq 'remove') {
	            $subject = "Ihr Account wurde geloescht.";
	            $mail_message = "Weitere Fragen koennen Sie gerne auf diese Mail stellen.";
	
							if (-e "$r_in->{'datadir'}/$_\.session") {
								unlink("$r_in->{'datadir'}/$_\.session");
							}
	
							if (-e "$r_in->{'datadir'}/$_\.log") {
								unlink("$r_in->{'datadir'}/$_\.log");
							}
	
	          }
	
	
	          if ($r_local->{'auth'}->{'Notify User on Act/Deactivation'} eq "on") {
	            send_mail($datadir, $r_local->{'auth'}->{'Sendmail Path'},
	            $r_local->{'auth'}->{'Admin EMail Address'},
	            $fields[$r_local->{'login_fields'}->{'EMail'}],
	            $subject,$mail_message );
	          }
         }
      }
		
      unless ($hit) {
# BIG5
#        my $temp = join("::",@fields);
        my $temp = join("\|",@fields);
        push(@rowdata,"$temp\n");
      }

    }
    
    writedata($r_local->{'password_file'},\@rowdata);

    $sub_heading = "User Manager Ergebnis";
    $html_output .= qq~
    <h4 align="center">
    Die User Datenbank wurde aktualisiert.
    </h4>
    ~;
  }

   else {

      $html_output .= qq~
      <form action="$r_local->{'thisurl'}" method="post">
      <input type="hidden" name="dc_action" value="$r_in->{'dc_action'}">
      <input type="hidden" name="command" value="list">
      <table border="0" width="100%" cellpadding="2">
      <tr bgcolor="$bg_color_3">
       <td colspan="2" >
			<font size="3" color="$font_color_3" face="$font_face_3">
		  <b>Option 1. Neuen User Account anlegen</b>
		  <font size="$font_size_3">
        <br>Klicken Sie auf den Button absenden um den neuen Account anzulegen.
		  </font>
      </font></td>
    <tr bgcolor="$bg_color_2">
      <th align="left" valign="top">&nbsp;</th>
		<th align="left">
			<font size="$font_size_2" color="$font_color_2" face="$font_face_2">
        <input type="radio" name="sub_action" value="new_user" checked>
        Neuen User Account erstellen</font></th></tr>
    <tr bgcolor="$bg_color_3"><td colspan="2">
		<font size="3" color="$font_color_3" face="$font_face_3">
		<b>Option 2. Einen Useraccount bearbeiten</b>
		<font size="$font_size_3">
		<br>Die Berarbeitung von User Account erfolgt in zwei Schritten:
		<li>Schritt 1, waehlen Sie die ersten Buchstaben des Users um die
		Auswahl einzuschraenken. Oder waehlen Sie 'All' um alle Accounts anzuzeigen.
		<li>Schritt 2. waehlen Sie die gewuenschte Funktion die ausgefuehrt werden soll.</font></font></td>
    </tr>
    <tr><th align="right" valign="top" bgcolor="$bg_color_2">
		<font size="$font_size_2" color="$font_color_2" face="$font_face_2">
      Schritt&nbsp;1.</font></th>
      <td bgcolor="$bg_color_1">
		<font size="$font_size_1" color="$font_color_1" face="$font_face_1">
      Waehlen Sie die ersten Buchstaben des Users um die Auswahl einzuschraenken.:
      <select name="user">
      <option value="all" selected>Alle
      <option value="a">a oder A
      <option value="b">b oder B
      <option value="c">c oder C
      <option value="d">d oder D
      <option value="e">e oder E
      <option value="f">f oder F
      <option value="g">g oder G
      <option value="h">h oder H
      <option value="i">i oder I
      <option value="j">j oder J
      <option value="k">k oder K
      <option value="l">l oder L
      <option value="m">m oder M
      <option value="n">n oder N
      <option value="o">o oder O
      <option value="p">p oder P
      <option value="q">q oder Q
      <option value="r">r oder R
      <option value="s">s oder S
      <option value="t">t oder T
      <option value="u">u oder U
      <option value="v">v oder V
      <option value="w">w oder W
      <option value="x">x oder X
      <option value="y">y oder Y
      <option value="z">z oder Z
      <option value="0">0
      <option value="1">1
      <option value="2">2
      <option value="3">3
      <option value="4">4
      <option value="5">5
      <option value="6">6
      <option value="7">7
      <option value="8">8
      <option value="9">9
      <option value="other">Andere
      </select></font>
      </td>
    </tr>
    <tr><th align="right" valign="top" bgcolor="$bg_color_2">
		<font size="$font_size_2" color="$font_color_2" face="$font_face_2">
      Step&nbsp;2.</font></th>
      <td bgcolor="$bg_color_1">
		<font size="$font_size_1" color="$font_color_1" face="$font_face_1">
        <input type="radio" name="sub_action" value="activate">
        <b>Inaktive User Accounts anzeigen:</b> Waehlen Sie 'All' um alle
		Inaktiven Accounts angezeigt zu bekommen.
        <br>
        <input type="radio" name="sub_action" value="deactivate">
        <b>User Accounts deaktivieren:</b>  Waehlen Sie 'All' um alle
		Aktiven Accounts angezeigt zu bekommen.
        <br>
        <input type="radio" name="sub_action" value="remove">
        <b>User Accounts loeschen:</b> Je genauer Sie den Usernamen angeben,
		umso schneller finden Sie den richtigen Account zum loeschen.
        <br>
        <input type="radio" name="sub_action" value="modify">
        <b>User Accounts bearbeiten:</b> Je genauer Sie den Usernamen angeben,
		umso schneller finden Sie den richtigen Account zum bearbeiten.
			 </font>
      </td>
    </tr>
    <tr bgcolor="$bg_color_3">
      <td colspan="2" align="center">
      <input type="submit" value="absenden">
      <input type="reset" value="l&ouml;schen">
      </td>
    </tr>
    </table>
    </form>~;
    
  }

  return $html_output;
}

###
#
# subroutine output_form
# Prints registration form to the browser
#
###

sub output_form {

   my ($r_in,$r_local) = @_;
   my ($temp_html);

   my $html_output .= qq~
   <form action="$r_local->{'thisurl'}" method="post">
   ~;
  
   if ($r_in->{'sub_action'} eq 'modify') {

# BIG5
#      $r_local->{'form_type'}->{'Group'} = 
#         "select::normal::member::team::moderator::admin";
      $r_local->{'form_type'}->{'Group'} = 
         "select|normal|member|team|moderator|admin";

      $html_output .= qq~
      <input type="hidden" name="dc_action" value="$r_in->{'dc_action'}">
      <input type="hidden" name="sub_action" value="$r_in->{'sub_action'}">
      <input type="hidden" name="command" value="save">
      ~;
   }
   elsif ($r_in->{'sub_action'} eq 'new_user') {

# BIG5
#      $r_local->{'form_type'}->{'Status'} = 
#         "hidden::$r_local->{'auth'}->{'Activate User on Register'}";
      $r_local->{'form_type'}->{'Status'} = 
         "hidden|$r_local->{'auth'}->{'Activate User on Register'}";

# BIG5
#      $r_local->{'form_type'}->{'Group'} = 
#         "select::normal::member::team::moderator";
      $r_local->{'form_type'}->{'Group'} = 
         "select|normal|member|team|moderator";

      $html_output .= qq~
      <input type="hidden" name="dc_action" value="$r_in->{'dc_action'}">
      <input type="hidden" name="sub_action" value="$r_in->{'sub_action'}">
      <input type="hidden" name="command" value="save">
      ~;
   }
   else {

      $r_local->{'form_type'}->{'Status'} = "";
      $r_local->{'form_type'}->{'Group'} = "";
      $html_output .= qq~
      <input type="hidden" name="dc_action" value="register">
      ~;
   }

	#If there are fields that must be passed to this page
	#do so now...

	foreach (@{$r_in->{'in_param'}}) {
		if ($r_in->{$_}) {
		   $html_output .= qq~
		   <input type="hidden" name="$_" value="$r_in->{$_}">
		   ~;
		}
	}

   $html_output .= qq~ 
   <table border="0" align="center">
   ~;

	my (%temp);

   foreach $field (@{$r_local->{'fields'}}) {

# BIG5
#      my @fields = split(/::/,$r_local->{'form_type'}->{$field});
      my @fields = split(/\|/,$r_local->{'form_type'}->{$field});
      my $required = pop(@fields);

      if ($required eq "required") {

         if (defined $temp{'required'}) {
            $temp{'required'} = join("\,",$temp{'required'},$field);
         } else {
            $temp{'required'} = $field;
         }
         $suffix = " <font color=\"#0000FF\"><b>*</b></font>:";
      }
      else {
         push(@fields,$required);
         $suffix = ":";
      }
    
      if ($fields[0] eq "text") {

         if ($field eq 'Username') {
            my $temp .= qq~
              <tr><th align="right" valign="top" bgcolor="$bg_color_2"><font 
				  size="$font_size_2" color="$font_color_2" face="$font_face_2">
				  $field$suffix</font></th>
              <td  bgcolor="$bg_color_2">
				  <input type="$fields[0]" name="$field"
              size="$fields[1]" value="$r_in->{$field}">
              </td></tr>
            ~;
            $temp_html = $temp . $temp_html;
         }
         else {
            $temp_html .= qq~
				<tr><th align="right" valign="top" bgcolor="$bg_color_2"><font 
				  size="$font_size_2" color="$font_color_2" face="$font_face_2">
				  $field$suffix</font></th>
              <td  bgcolor="$bg_color_2">
				<input type="$fields[0]" name="$field"
              size="$fields[1]" value="$r_in->{$field}">
            </td></tr>
      	   ~;
			}
      }
      elsif ($fields[0] eq "password") {
	  

         $temp_html .= qq~
         <tr><th align="right" valign="top" bgcolor="$bg_color_2"><font 
				  size="$font_size_2" color="$font_color_2" face="$font_face_2">
			$field$suffix</font></th>
         <td  bgcolor="$bg_color_2">
				  <input type="$fields[0]" name="$field"
         size="$fields[1]" value="$r_in->{$field}"></td></tr>~;

         if ($r_in->{'sub_action'} eq 'modify') {
            $temp_html .= qq~
				<tr><th align="right" valign="top" bgcolor="$bg_color_2"><font 
				  size="$font_size_2" color="$font_color_2" face="$font_face_2">
				  					$field again$suffix</font></th>
               <td  bgcolor="$bg_color_2">
					<input type="$fields[0]" name="dup_$field" 
               size="$fields[1]" value="$r_in->{$field}">
              </td></tr>
            ~;
         }
         else {

            $temp_html .= qq~
            <tr><th align="right" valign="top" bgcolor="$bg_color_2"><font 
				  size="$font_size_2" color="$font_color_2" face="$font_face_2">
				  $field again$suffix</font></th>
            <td  bgcolor="$bg_color_2">
				  <input type="$fields[0]" name="dup_$field"
               size="$fields[1]" value="$r_in->{"dup_" . $field}">
            </td></tr>
            ~;
         }

	      if ($r_local->{'auth'}->{'Register Via EMail'} eq "on" 
			     and $r_in->{'sub_action'} ne 'modify' and $r_in->{'sub_action'} ne 'new_user') {
				$temp_html = '';
         }


      }

      elsif ($fields[0] eq "hidden") {

         if ($field eq 'Password') {
            $temp_html .= qq~
					<tr><td>
				<input type="$fields[0]" name="$field" value="$fields[1]">
            <input type="$fields[0]" name="dup_$field" value="$fields[1]">
            </td></tr>
            ~;
         }
         else {
            $temp_html .= qq~
            <tr><td>
            <input type="$fields[0]" name="$field" value="$fields[1]">
            </td></tr>
            ~;
         }
      }
		
      elsif ($fields[0] eq "radio" || $fields[0] eq "checkbox") {
      
	      $temp_html .= qq~
	        <tr><th align="right" valign="top" bgcolor="$bg_color_2"><font 
				  size="$font_size_2" color="$font_color_2" face="$font_face_2">
				$field$suffix</font></th>
			<td bgcolor="$bg_color_2">
	      ~;
	      my $type = $fields[0];

	      shift(@fields);

	      foreach (@fields) {
            if ($_ eq $r_in->{$field}) {
               $temp_html .= qq~
               <input type="$type" name="$field" value="$_" checked>$_
               ~;
            }
            else {
               $temp_html .= qq~
               <input type="$type" name="$field" value="$_" >$_
               ~;
            }
         }

         $temp_html .= qq~
         </td></tr>~;
      }
    
      elsif ($fields[0] eq "select") {
      
         $temp_html .= qq~
         <th align="right" valign="top" bgcolor="$bg_color_2"><font 
				  size="$font_size_2" color="$font_color_2" face="$font_face_2">$field$suffix</font></th>
         <td align="left" bgcolor="$bg_color_2">
				  <select name="$field">
         ~;
         shift(@fields);

         foreach (@fields) {
            if ($_ eq $r_in->{$field}) {
               $temp_html .= qq~
               <option value="$_" selected>$_
               ~;
            }
            else {
               $temp_html .= qq~
               <option value="$_">$_
               ~;        
            }
         }
			
         $temp_html .= qq~
         </select></td></tr>
         ~;
      }
    
      elsif ($fields[0] eq "textarea") {
      
         $temp_html .= qq~
         <tr><th align="right" valign="top" bgcolor="$bg_color_2"><font 
				  size="$font_size_2" color="$font_color_2" face="$font_face_2">$field$suffix</font></th>
         <td bgcolor="$bg_color_2"><textarea name="$field" rows="$fields[1]" 
          cols="$fields[2]" wrap="physical">$r_in->{$field}</textarea>
          </td></tr>
         ~;
      }

   }

   $html_output .= qq~
   $temp_html
        <tr><th>&nbsp;
        <input type="hidden" name="required" value="$temp{'required'}"></th>
        <td><input type="submit" value="Registrierung absenden">
          <input type="reset" value="l&ouml;schen">
        </td></tr>
   </table>
   </form>
   ~;

}


###
#
# subroutine display_logon
# Displays logon page
#
###


sub display_logon {

   my ($r_in,$r_local) = @_;

   # First print form tags
   my $html_output .= qq~
   <form action="$r_local->{'thisurl'}" method="post">
   <input type="hidden" name="dc_action" value="login">
   ~;

	foreach (@{$r_in->{'in_param'}}) {
		if ($r_in->{$_}) {
		   $html_output .= qq~
		   <input type="hidden" name="$_" value="$r_in->{$_}">
		   ~;
		}
	}

   $html_output .= qq~
   <table border="0" align="center"><tr bgcolor="$bg_color_3">
    <th align="right">
    <font size="$font_size_3" color="$font_color_3" face="$font_face_3">
      Username:</font></th>
    <td><input type="text" name="Username" width="40"></td></tr>
    <tr bgcolor="$bg_color_3">
    <th align="right">
    <font size="$font_size_3" color="$font_color_3" face="$font_face_3">
	Passwort:</font></th>
    <td><input type="password" name="Password" width="40"></td></tr>~;

  if ($r_local->{'auth'}->{'Allow Remembering of Password'} eq 'on') {
	  $html_output .= qq~
	  <tr bgcolor="$bg_color_3"><td align="right">
	      <input type="checkbox" name="remember" value="YES">
	      </td><td align="left">
	     <font size="1" color="$font_color_3" face="$font_face_3">
	      Wollen Sie Ihr Passwort speichern?</font>
			</td></tr>~;
  }
  $html_output .= qq~
  <tr bgcolor="$bg_color_3">
    <td>
    &nbsp;
    </td>
    <td align="left">
      <input type="submit" name="login" value="Login">
  ~;

  if ($r_local->{'auth'}->{'Allow Users to Register'} eq 'on') {
    $html_output .= qq~
      <input type="submit" name="Register" value="Registrierung">
    ~;
  }
  
  $html_output .= qq~
    </td></tr>
  </table>
  </form>
~;

}


################################################################
#
# subroutine register
# Completes the registration process
#
################################################################

sub register {

   my ($r_in,$r_local) = @_;
   my ($error);

	if ($r_in->{'Username'} =~ /\W/) {
  	   my $error = "Your Username can only contain alphanumeric characters and/or an underscore.";
    	return $error;
	}

   # Get record according to the Username

	unless ($r_in->{'Password'} eq $r_in->{'dup_Password'}) {
  	   my $error = "Passwords are not same";
    	return $error;
       }
 
   if ($r_in->{'EMail'}) {
 
       my ($temp1,$temp2) = split(/\@/,$r_in->{'EMail'});

       if ($r_local->{'auth'}->{'Bad EMail List'} =~ /$temp2/i) {
 
	    my $error .= qq~
	       <b>Falsche Email Adresse</b><p>
	       Aus Sicherheitsgruenden sind anonyme Email Adressen nicht erlaubt.<br>
		    Bitte benutzen Sie Ihre richtige Email Adresse.<br>~;
          return $error;
       }
   }

   $error = check_dup_user($r_in,$r_local);

   if ($error) {
      return $error;
   }

	# OK, we can now register the user and update the database

   foreach (@{$r_local->{'fields'}}) {

   	if ($_ eq "Password") {

		# Following code is from Selena Sol's authentication script
		# This is to keep file format intact

     		srand(time|$$);
     		my $salt = "";
     		my $random = "abcdefghijklmnopqrstuvwxyz1234567890";
     		for (1..2) {
       		$salt .= substr($random,int(rand(36)),1);
     		}
     		$r_in->{$_} = my_crypt($r_in->{$_},$salt);

   	}
		elsif ($_ eq "Group") {

			unless (-s $r_local->{'password_file'} > 0) {
 				$r_in->{$_} = 'admin';
			}
			else {

				if ($r_in->{'sub_action'} eq 'new_user') {
					$r_in->{$_} = $r_in->{'Group'};
				}
				else {
					$r_in->{$_} = $r_local->{'auth'}->{'Default Group'};
				}

			} #End of unless

		}
		elsif ($_ eq "Status") {
			$r_in->{$_} = $r_local->{'auth'}->{'Activate User on Register'};
		}
		elsif ($_ eq "EMail") {
			$r_in->{$_} = add_antispam($r_in->{$_});
		}		
   	push(@line,$r_in->{$_});
 	}

# BIG5
# 	$line = join("::",@line);
 	$line = join("\|",@line);
 	appenddata($r_local->{'password_file'},$line);

	if ($r_local->{'auth'}->{'Register Via EMail'} eq "on") {
		# sendmail here
	}

  return 0;

}

#####
# subroutine update_user
# Updates user information
#
###

sub update_user {

   my ($r_in,$r_local) = @_;
   my ($error);
   my $r_data = readdata($r_local->{'password_file'});

   unless ($r_in->{'Password'} eq $r_in->{'dup_Password'}) {
      $error = "Die neuen Passwoerter stimmen nicht ueberein";
      return $error;
   }

   my @new_data;

   foreach (@$r_data) {

      chomp;
# BIG5
#      my $r_entry = [ split(/::/,$_) ];
      my $r_entry = [ split(/\|/,$_) ];
			
      if ($r_entry->[$r_local->{'login_fields'}->{'Username'}] eq $r_in->{'Username'}) {

         foreach (@{$r_local->{'fields'}}) {

         	if ($_ eq 'Password') {
            	if ($r_in->{$_} ne $r_entry->[$r_local->{'login_fields'}->{$_}] ) {
		            srand(time|$$);
		            my $salt = "";
		            my $random = "abcdefghijklmnopqrstuvwxyz1234567890";

		            for (1..2) {
		              $salt .= substr($random,int(rand(36)),1);
		            }
						unless ($r_in->{'no_crypt'}) {
		            	$r_in->{$_} = my_crypt($r_in->{$_},$salt);
						}
	            }
	         }
				elsif ($_ eq "EMail") {
					$r_in->{$_} =~ s/(REMOVE_THIS)+//;
					$r_in->{$_} = add_antispam($r_in->{$_});
				} #End of if

            push(@line,$r_in->{$_});

         } #End of Foreach

# BIG5
#         $line = join("::",@line);
         $line = join("\|",@line);
         $line .= "\n";

      }
      else {
         $line = "$_\n";
      }

      push(@new_data,$line);

   }

   writedata($r_local->{'password_file'},\@new_data);

# next update *.session file

	my @temp_array;

   foreach (keys %{ $r_local->{'login_fields'} }) {
		unless ($_ eq "Password") {
			my $temp_string = join ("::",$_,$r_in->{$_});
       		push(@temp_array,"$temp_string\n");
		}
   }
			
   # Create session file
#	writedata_nolock("$r_in->{'datadir'}/$r_in->{'session'}\.session",\@temp_array);

   return $error;

}


####
#
# subroutine check_password
#
###

sub check_password {

  my ($r_in,$r_local) = @_;
  my ($error);
	my ($orig_username, $orig_password, $test_password);

  # Get record according to the Username
  # This sets $r_local->{'login_info'}
  
  get_login_data($r_local->{'password_file'},$r_in->{'Username'},$r_local);

  $orig_username = $r_local->{'login_info'}->{'Username'};
  $orig_password = $r_local->{'login_info'}->{'Password'};

  $test_password = 
    my_crypt($r_in->{'Password'},$orig_password);

  if (!$orig_username) {
    $error = "Unbekannter Username";
    return $error;
  }
  elsif ($orig_password ne $test_password) {
    $error = "Falsches Passwort";
    return $error;
  }
  elsif ($r_local->{'login_info'}->{'Status'} ne "on") {
    $error = "Ihr Account wurde noch nicht aktiviert";
    return $error;
  }
  else {   
    foreach (@{$r_local->{'fields'}}) {
      $r_in->{$_} = 
        $r_local->{'login_info'}->{$_};
    }
  }
}


###
### subroutine get_login_data
### Read in all the username and password
### Then, pull off the record that matches
### Input username
###

sub get_login_data {

  my ($password_file,$username,$r_local) = @_;
  my $r_data = readdata($password_file);

  foreach (@$r_data) {
    chomp;
# BIG5
#    my $r_entry = [ split(/::/,$_) ];
    my $r_entry = [ split(/\|/,$_) ];
    if ($r_entry->[$r_local->{'login_fields'}->{'Username'}] 
            eq $username) {
      foreach (keys %{ $r_local->{'login_fields'} }) {
        $r_local->{'login_info'}->{$_} = 
				$r_entry->[$r_local->{'login_fields'}->{$_}];
      }
    }
  }

  $r_local->{'name'} = $username;
  return;
}

###
### subroutine check_dup_user
### Read in all the username and password
### Then, pull off the record that matches
### Input username
###

sub check_dup_user {

  my ($r_in,$r_local) = @_;
  my $r_data = readdata($r_local->{'password_file'});
  my $status;

  foreach (@$r_data) {
    chomp;
# BIG5
#    my $r_entry = [ split(/::/,$_) ];
    my $r_entry = [ split(/\|/,$_) ];

    if ($r_entry->[$r_local->{'login_fields'}->{'Username'}] 
            eq $r_in->{'Username'}) {
        $status = "dup_user";
        return $status;
    }
  }
}


###
### subroutine get_user_list
### Read in all the username and password
### Used for user management
###

sub get_user_list {

   my ($r_in,$r_local,$status) = @_;

   my $r_data = readdata($r_local->{'password_file'});

	# If Group_type is specified, then pull of all the
	# users with this group type

   if ($r_in->{'Group_type'} eq 'team') {
	   foreach (@$r_data) {
	      chomp;
# BIG5
#	      my $r_entry = [ split(/::/,$_) ];
	      my $r_entry = [ split(/\|/,$_) ];
         unless ($r_entry->[$r_local->{'login_fields'}->{'Group'}]
            eq 'normal' or $r_entry->[$r_local->{'login_fields'}->{'Group'}] eq 'member') {
               push( @{$r_local->{'user_list'} }, $r_entry);
         }
	
	   }#End of foreach	
	}
   elsif ($r_in->{'Group_type'}) {

	   foreach (@$r_data) {
	      chomp;
# BIG5
#	      my $r_entry = [ split(/::/,$_) ];
	      my $r_entry = [ split(/\|/,$_) ];
         if ($r_entry->[$r_local->{'login_fields'}->{'Group'}]
            eq $r_in->{'Group_type'}) {
               push( @{$r_local->{'user_list'} }, $r_entry);
         }
	
	   }#End of foreach	
	}
	else {

	   foreach (@$r_data) {
	      chomp;
# BIG5
#	      my $r_entry = [ split(/::/,$_) ];
	      my $r_entry = [ split(/\|/,$_) ];
	    
	      if ($status ne "" &&
	         $r_entry->[$r_local->{'login_fields'}->{'Status'}] eq $status) {
	
	         if ($r_in->{'user'} eq 'all') {
	            push( @{$r_local->{'user_list'} }, $r_entry);
	         }
	         else {
	            if ($r_entry->[$r_local->{'login_fields'}->{'Username'}]
	            =~ /^$r_in->{'user'}/i) {
	               push( @{$r_local->{'user_list'} }, $r_entry);
	            }
	         }
	      }
	      elsif ($status eq "") {
	
	         if ($r_in->{'user'} eq 'all') {
	            push( @{$r_local->{'user_list'} }, $r_entry);
	         }
	         else {
	            if ($r_entry->[$r_local->{'login_fields'}->{'Username'}]
	               =~ /^$r_in->{'user'}/i) {
	               push( @{$r_local->{'user_list'} }, $r_entry);
	            }
	         }
	
		   }#End of if ($status...
	
	   }#End of foreach

   }
}

#####
#
# subroutine check_group
#
#####

sub check_group {

  my ($r_in,$r_local,$group) = @_;

  my ($heading,$sub_heading,$html_outout);

  if ($r_local->{'login_info'}->{'Group'} ne $group) {
    $heading = "DCForum User Manager";
    $sub_heading = "Fehler - falsche Usergruppe";
    $html_output .= qq~
   <h4 align="center">
   Sie haben keine Administrationrechte fuer diesen Vorgang.
    </h4>
   ~;
   
    $html_output .= display_logon($r_in,$r_local);

    my %namespace = (
      HEADER => $heading,
      SUBHEADER => $sub_heading,
      HTMLOUTPUT => $html_output );

    display_output($templatefile,\%namespace); 
    exit;
  }

  return;
}

#####
#
# Subroutine get_session_id
# Generates session ID for a User.
# This portion of code from Selena and Gunther's
# auth-extra-lib.pl
#
####


sub get_session_id {

	my ($session, $session_file);

	# Seed the random generator
	srand($$|time);
	$session = int(rand(60000));

	# pack the time, process id, and random $session into a
	# hex number which will make up the session id.

	$session = unpack("H*", pack("Nnn", time, $$, $session));

} # End of MakeSessionFile



###################################################################
#
# subroutine menu
#
###################################################################

sub menu {

   my ($r_in) = @_;

   my $menu .=qq~
      <TABLE BORDER="0" CELLPADDING="4" ALIGN="CENTER">
   	<TR>
      <TH ALIGN="LEFT" colspan="2">
		  	<font size="2" mesg="verdana" color="#000099">
    [ <a href="$homeurl">Homepage</a> ]
    [ <a href="$adminurl">Administration &Uuml;bersicht</a> ]
    [ <a href="$boardurl">Zur Foren Lobby</a> ]</font>
      </TH>
   </TR>
	</TABLE>
   ~;

}

1;
